   1              		.syntax unified
   2              		.cpu cortex-m4
   3              		.fpu softvfp
   4              		.eabi_attribute 20, 1
   5              		.eabi_attribute 21, 1
   6              		.eabi_attribute 23, 3
   7              		.eabi_attribute 24, 1
   8              		.eabi_attribute 25, 1
   9              		.eabi_attribute 26, 1
  10              		.eabi_attribute 30, 6
  11              		.eabi_attribute 34, 1
  12              		.eabi_attribute 18, 4
  13              		.thumb
  14              		.syntax unified
  15              		.file	"gol_benchmark.c"
  16              		.text
  17              	.Ltext0:
  18              		.cfi_sections	.debug_frame
  19              		.comm	prevent_compiler_opt,4,4
  20              		.bss
  21              		.align	2
  22              	world_0:
  23 0000 00000000 		.space	4096
  23      00000000 
  23      00000000 
  23      00000000 
  23      00000000 
  24              		.align	2
  25              	world_1:
  26 1000 00000000 		.space	4096
  26      00000000 
  26      00000000 
  26      00000000 
  26      00000000 
  27              		.align	2
  28              	rand_state:
  29 2000 00000000 		.space	4
  30              		.text
  31              		.align	2
  32              		.thumb
  33              		.thumb_func
  35              	Random:
  36              	.LFB0:
  37              		.file 1 "gol_benchmark.c"
   1:gol_benchmark.c **** /*************************************************************************
   2:gol_benchmark.c **** "Conway's Game of Life" benchmark for 8 bit and 32 bit data types.
   3:gol_benchmark.c **** The calculations start with a pseudo-random, but reproducible world. The
   4:gol_benchmark.c **** calculations are identical in every benchmark call with the same number
   5:gol_benchmark.c **** of generations.
   6:gol_benchmark.c **** 
   7:gol_benchmark.c **** resource requirements:
   8:gol_benchmark.c **** needs about 8 kB RAM for the "game of life" worlds at 32x32 cells.
   9:gol_benchmark.c **** 
  10:gol_benchmark.c **** external requirements:
  11:gol_benchmark.c **** needs the following get-time function:
  12:gol_benchmark.c **** int32_t Get_Time(void);
  13:gol_benchmark.c **** 
  14:gol_benchmark.c **** benchmark functions:
  15:gol_benchmark.c **** int32_t Gol_Benchmark_8(uint32_t num_generations);
  16:gol_benchmark.c **** int32_t Gol_Benchmark_32(uint32_t num_generations);
  17:gol_benchmark.c **** 
  18:gol_benchmark.c **** input:        desired number of generations.
  19:gol_benchmark.c **** 
  20:gol_benchmark.c **** output:       difference between Get_Time() at start and end, in whatever
  21:gol_benchmark.c ****               unit the Get_Time() function is using. The initialization
  22:gol_benchmark.c ****               is not part of the benchmark.
  23:gol_benchmark.c **** 
  24:gol_benchmark.c **** side effects: the volatile global variable "prevent_compiler_opt" is set
  25:gol_benchmark.c ****               to the final state of the middle "game of life" cell. This
  26:gol_benchmark.c ****               keeps the compiler from optimizing the benchmark away.
  27:gol_benchmark.c **** 
  28:gol_benchmark.c **** limitations:  cell 0 is not updated, and the border wrapping is strange,
  29:gol_benchmark.c ****               but it doesn't matter for benchmarking.
  30:gol_benchmark.c **** *************************************************************************/
  31:gol_benchmark.c **** 
  32:gol_benchmark.c **** #include <stdint.h>
  33:gol_benchmark.c **** 
  34:gol_benchmark.c **** //#define SIGNED_TEST
  35:gol_benchmark.c **** 
  36:gol_benchmark.c **** #ifdef SIGNED_TEST
  37:gol_benchmark.c ****     #define INT8 int8_t
  38:gol_benchmark.c ****     #define INT32 int32_t
  39:gol_benchmark.c **** #else
  40:gol_benchmark.c ****     #define INT8 uint8_t
  41:gol_benchmark.c ****     #define INT32 uint32_t
  42:gol_benchmark.c **** #endif
  43:gol_benchmark.c **** 
  44:gol_benchmark.c **** #define DEAD      0
  45:gol_benchmark.c **** #define ALIVE     1U
  46:gol_benchmark.c **** 
  47:gol_benchmark.c **** /*must be powers of 2*/
  48:gol_benchmark.c **** #define ROWS      32UL
  49:gol_benchmark.c **** #define COLS      32UL
  50:gol_benchmark.c **** 
  51:gol_benchmark.c **** #define WRAP_MASK (ROWS * COLS - 1UL)
  52:gol_benchmark.c **** 
  53:gol_benchmark.c **** extern int32_t Get_Time(void);
  54:gol_benchmark.c **** 
  55:gol_benchmark.c **** volatile INT32 prevent_compiler_opt;
  56:gol_benchmark.c **** 
  57:gol_benchmark.c **** /*reuse the worlds for the 8 bit test via pointer casting*/
  58:gol_benchmark.c **** static INT32 world_0[ROWS * COLS];
  59:gol_benchmark.c **** static INT32 world_1[ROWS * COLS];
  60:gol_benchmark.c **** 
  61:gol_benchmark.c **** static uint32_t rand_state;
  62:gol_benchmark.c **** 
  63:gol_benchmark.c **** static uint32_t Random(uint32_t max_val) {
  38              		.loc 1 63 0
  39              		.cfi_startproc
  40              		@ args = 0, pretend = 0, frame = 8
  41              		@ frame_needed = 1, uses_anonymous_args = 0
  42              		@ link register save eliminated.
  43 0000 80B4     		push	{r7}
  44              		.cfi_def_cfa_offset 4
  45              		.cfi_offset 7, -4
  46 0002 83B0     		sub	sp, sp, #12
  47              		.cfi_def_cfa_offset 16
  48 0004 00AF     		add	r7, sp, #0
  49              		.cfi_def_cfa_register 7
  50 0006 7860     		str	r0, [r7, #4]
  64:gol_benchmark.c ****     rand_state *= 1103515245UL;
  51              		.loc 1 64 0
  52 0008 0E4B     		ldr	r3, .L3
  53 000a 1B68     		ldr	r3, [r3]
  54 000c 0E4A     		ldr	r2, .L3+4
  55 000e 02FB03F3 		mul	r3, r2, r3
  56 0012 0C4A     		ldr	r2, .L3
  57 0014 1360     		str	r3, [r2]
  65:gol_benchmark.c ****     rand_state += 12345UL;
  58              		.loc 1 65 0
  59 0016 0B4B     		ldr	r3, .L3
  60 0018 1B68     		ldr	r3, [r3]
  61 001a 03F54053 		add	r3, r3, #12288
  62 001e 3933     		adds	r3, r3, #57
  63 0020 084A     		ldr	r2, .L3
  64 0022 1360     		str	r3, [r2]
  66:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
  65              		.loc 1 66 0
  66 0024 074B     		ldr	r3, .L3
  67 0026 1B68     		ldr	r3, [r3]
  68 0028 1B0C     		lsrs	r3, r3, #16
  69 002a 7A68     		ldr	r2, [r7, #4]
  70 002c B3FBF2F2 		udiv	r2, r3, r2
  71 0030 7968     		ldr	r1, [r7, #4]
  72 0032 01FB02F2 		mul	r2, r1, r2
  73 0036 9B1A     		subs	r3, r3, r2
  67:gol_benchmark.c **** }
  74              		.loc 1 67 0
  75 0038 1846     		mov	r0, r3
  76 003a 0C37     		adds	r7, r7, #12
  77              		.cfi_def_cfa_offset 4
  78 003c BD46     		mov	sp, r7
  79              		.cfi_def_cfa_register 13
  80              		@ sp needed
  81 003e 80BC     		pop	{r7}
  82              		.cfi_restore 7
  83              		.cfi_def_cfa_offset 0
  84 0040 7047     		bx	lr
  85              	.L4:
  86 0042 00BF     		.align	2
  87              	.L3:
  88 0044 00200000 		.word	rand_state
  89 0048 6D4EC641 		.word	1103515245
  90              		.cfi_endproc
  91              	.LFE0:
  93              		.align	2
  94              		.thumb
  95              		.thumb_func
  97              	Gol_Init_8:
  98              	.LFB1:
  68:gol_benchmark.c **** 
  69:gol_benchmark.c **** static void Gol_Init_8(INT8 *world_8) {
  99              		.loc 1 69 0
 100              		.cfi_startproc
 101              		@ args = 0, pretend = 0, frame = 16
 102              		@ frame_needed = 1, uses_anonymous_args = 0
 103 004c 90B5     		push	{r4, r7, lr}
 104              		.cfi_def_cfa_offset 12
 105              		.cfi_offset 4, -12
 106              		.cfi_offset 7, -8
 107              		.cfi_offset 14, -4
 108 004e 85B0     		sub	sp, sp, #20
 109              		.cfi_def_cfa_offset 32
 110 0050 00AF     		add	r7, sp, #0
 111              		.cfi_def_cfa_register 7
 112 0052 7860     		str	r0, [r7, #4]
  70:gol_benchmark.c ****     uint32_t cnt;
  71:gol_benchmark.c ****     rand_state = 42UL; /*pseudo-random, reproducible init*/
 113              		.loc 1 71 0
 114 0054 0C4B     		ldr	r3, .L8
 115 0056 2A22     		movs	r2, #42
 116 0058 1A60     		str	r2, [r3]
  72:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
 117              		.loc 1 72 0
 118 005a 0023     		movs	r3, #0
 119 005c FB60     		str	r3, [r7, #12]
 120 005e 0BE0     		b	.L6
 121              	.L7:
  73:gol_benchmark.c ****         world_8[cnt] = (INT8) Random(ALIVE+1UL);
 122              		.loc 1 73 0 discriminator 3
 123 0060 7A68     		ldr	r2, [r7, #4]
 124 0062 FB68     		ldr	r3, [r7, #12]
 125 0064 D418     		adds	r4, r2, r3
 126 0066 0220     		movs	r0, #2
 127 0068 FFF7CAFF 		bl	Random
 128 006c 0346     		mov	r3, r0
 129 006e DBB2     		uxtb	r3, r3
 130 0070 2370     		strb	r3, [r4]
  72:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
 131              		.loc 1 72 0 discriminator 3
 132 0072 FB68     		ldr	r3, [r7, #12]
 133 0074 0133     		adds	r3, r3, #1
 134 0076 FB60     		str	r3, [r7, #12]
 135              	.L6:
  72:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
 136              		.loc 1 72 0 is_stmt 0 discriminator 1
 137 0078 FB68     		ldr	r3, [r7, #12]
 138 007a B3F5806F 		cmp	r3, #1024
 139 007e EFD3     		bcc	.L7
  74:gol_benchmark.c **** }
 140              		.loc 1 74 0 is_stmt 1
 141 0080 00BF     		nop
 142 0082 1437     		adds	r7, r7, #20
 143              		.cfi_def_cfa_offset 12
 144 0084 BD46     		mov	sp, r7
 145              		.cfi_def_cfa_register 13
 146              		@ sp needed
 147 0086 90BD     		pop	{r4, r7, pc}
 148              	.L9:
 149              		.align	2
 150              	.L8:
 151 0088 00200000 		.word	rand_state
 152              		.cfi_endproc
 153              	.LFE1:
 155              		.align	2
 156              		.thumb
 157              		.thumb_func
 159              	Gol_Init_32:
 160              	.LFB2:
  75:gol_benchmark.c **** 
  76:gol_benchmark.c **** static void Gol_Init_32(INT32 *world_32) {
 161              		.loc 1 76 0
 162              		.cfi_startproc
 163              		@ args = 0, pretend = 0, frame = 16
 164              		@ frame_needed = 1, uses_anonymous_args = 0
 165 008c 90B5     		push	{r4, r7, lr}
 166              		.cfi_def_cfa_offset 12
 167              		.cfi_offset 4, -12
 168              		.cfi_offset 7, -8
 169              		.cfi_offset 14, -4
 170 008e 85B0     		sub	sp, sp, #20
 171              		.cfi_def_cfa_offset 32
 172 0090 00AF     		add	r7, sp, #0
 173              		.cfi_def_cfa_register 7
 174 0092 7860     		str	r0, [r7, #4]
  77:gol_benchmark.c ****     uint32_t cnt;
  78:gol_benchmark.c ****     rand_state = 42UL; /*pseudo-random, reproducible init*/
 175              		.loc 1 78 0
 176 0094 0C4B     		ldr	r3, .L13
 177 0096 2A22     		movs	r2, #42
 178 0098 1A60     		str	r2, [r3]
  79:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
 179              		.loc 1 79 0
 180 009a 0023     		movs	r3, #0
 181 009c FB60     		str	r3, [r7, #12]
 182 009e 0BE0     		b	.L11
 183              	.L12:
  80:gol_benchmark.c ****         world_32[cnt] = (INT32) Random(ALIVE+1UL);
 184              		.loc 1 80 0 discriminator 3
 185 00a0 FB68     		ldr	r3, [r7, #12]
 186 00a2 9B00     		lsls	r3, r3, #2
 187 00a4 7A68     		ldr	r2, [r7, #4]
 188 00a6 D418     		adds	r4, r2, r3
 189 00a8 0220     		movs	r0, #2
 190 00aa FFF7A9FF 		bl	Random
 191 00ae 0346     		mov	r3, r0
 192 00b0 2360     		str	r3, [r4]
  79:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
 193              		.loc 1 79 0 discriminator 3
 194 00b2 FB68     		ldr	r3, [r7, #12]
 195 00b4 0133     		adds	r3, r3, #1
 196 00b6 FB60     		str	r3, [r7, #12]
 197              	.L11:
  79:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
 198              		.loc 1 79 0 is_stmt 0 discriminator 1
 199 00b8 FB68     		ldr	r3, [r7, #12]
 200 00ba B3F5806F 		cmp	r3, #1024
 201 00be EFD3     		bcc	.L12
  81:gol_benchmark.c **** }
 202              		.loc 1 81 0 is_stmt 1
 203 00c0 00BF     		nop
 204 00c2 1437     		adds	r7, r7, #20
 205              		.cfi_def_cfa_offset 12
 206 00c4 BD46     		mov	sp, r7
 207              		.cfi_def_cfa_register 13
 208              		@ sp needed
 209 00c6 90BD     		pop	{r4, r7, pc}
 210              	.L14:
 211              		.align	2
 212              	.L13:
 213 00c8 00200000 		.word	rand_state
 214              		.cfi_endproc
 215              	.LFE2:
 217              		.align	2
 218              		.thumb
 219              		.thumb_func
 221              	Gol_Iteration_8:
 222              	.LFB3:
  82:gol_benchmark.c **** 
  83:gol_benchmark.c **** static void Gol_Iteration_8(const INT8 *old_world, INT8 *new_world) {
 223              		.loc 1 83 0
 224              		.cfi_startproc
 225              		@ args = 0, pretend = 0, frame = 24
 226              		@ frame_needed = 1, uses_anonymous_args = 0
 227              		@ link register save eliminated.
 228 00cc 80B4     		push	{r7}
 229              		.cfi_def_cfa_offset 4
 230              		.cfi_offset 7, -4
 231 00ce 87B0     		sub	sp, sp, #28
 232              		.cfi_def_cfa_offset 32
 233 00d0 00AF     		add	r7, sp, #0
 234              		.cfi_def_cfa_register 7
 235 00d2 7860     		str	r0, [r7, #4]
 236 00d4 3960     		str	r1, [r7]
  84:gol_benchmark.c ****     uint32_t base_cell;
  85:gol_benchmark.c ****     /*some simplifications here to avoid benchmarking the loop overhead
  86:gol_benchmark.c ****       or the wrapping.
  87:gol_benchmark.c ****       cell 0 is not updated, and the wrapping is strange, but it doesn't
  88:gol_benchmark.c ****       matter for benchmarking.*/
  89:gol_benchmark.c ****     for (base_cell = ROWS * COLS - 1UL; base_cell != 0; base_cell--) {
 237              		.loc 1 89 0
 238 00d6 40F2FF33 		movw	r3, #1023
 239 00da 7B61     		str	r3, [r7, #20]
 240 00dc 7FE0     		b	.L16
 241              	.L23:
 242              	.LBB2:
  90:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
  91:gol_benchmark.c **** 
  92:gol_benchmark.c ****         /*counting from upper left adjacent, clockwise*/
  93:gol_benchmark.c ****         living_adjacents  = old_world[(base_cell - COLS - 1UL) & WRAP_MASK];
 243              		.loc 1 93 0
 244 00de 7B69     		ldr	r3, [r7, #20]
 245 00e0 213B     		subs	r3, r3, #33
 246 00e2 C3F30903 		ubfx	r3, r3, #0, #10
 247 00e6 7A68     		ldr	r2, [r7, #4]
 248 00e8 1344     		add	r3, r3, r2
 249 00ea 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 250 00ec 3B61     		str	r3, [r7, #16]
  94:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 251              		.loc 1 94 0
 252 00ee 7B69     		ldr	r3, [r7, #20]
 253 00f0 203B     		subs	r3, r3, #32
 254 00f2 C3F30903 		ubfx	r3, r3, #0, #10
 255 00f6 7A68     		ldr	r2, [r7, #4]
 256 00f8 1344     		add	r3, r3, r2
 257 00fa 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 258 00fc 1A46     		mov	r2, r3
 259 00fe 3B69     		ldr	r3, [r7, #16]
 260 0100 1344     		add	r3, r3, r2
 261 0102 3B61     		str	r3, [r7, #16]
  95:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 262              		.loc 1 95 0
 263 0104 7B69     		ldr	r3, [r7, #20]
 264 0106 1F3B     		subs	r3, r3, #31
 265 0108 C3F30903 		ubfx	r3, r3, #0, #10
 266 010c 7A68     		ldr	r2, [r7, #4]
 267 010e 1344     		add	r3, r3, r2
 268 0110 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 269 0112 1A46     		mov	r2, r3
 270 0114 3B69     		ldr	r3, [r7, #16]
 271 0116 1344     		add	r3, r3, r2
 272 0118 3B61     		str	r3, [r7, #16]
  96:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 273              		.loc 1 96 0
 274 011a 7B69     		ldr	r3, [r7, #20]
 275 011c 0133     		adds	r3, r3, #1
 276 011e C3F30903 		ubfx	r3, r3, #0, #10
 277 0122 7A68     		ldr	r2, [r7, #4]
 278 0124 1344     		add	r3, r3, r2
 279 0126 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 280 0128 1A46     		mov	r2, r3
 281 012a 3B69     		ldr	r3, [r7, #16]
 282 012c 1344     		add	r3, r3, r2
 283 012e 3B61     		str	r3, [r7, #16]
  97:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 284              		.loc 1 97 0
 285 0130 7B69     		ldr	r3, [r7, #20]
 286 0132 2133     		adds	r3, r3, #33
 287 0134 C3F30903 		ubfx	r3, r3, #0, #10
 288 0138 7A68     		ldr	r2, [r7, #4]
 289 013a 1344     		add	r3, r3, r2
 290 013c 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 291 013e 1A46     		mov	r2, r3
 292 0140 3B69     		ldr	r3, [r7, #16]
 293 0142 1344     		add	r3, r3, r2
 294 0144 3B61     		str	r3, [r7, #16]
  98:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 295              		.loc 1 98 0
 296 0146 7B69     		ldr	r3, [r7, #20]
 297 0148 2033     		adds	r3, r3, #32
 298 014a C3F30903 		ubfx	r3, r3, #0, #10
 299 014e 7A68     		ldr	r2, [r7, #4]
 300 0150 1344     		add	r3, r3, r2
 301 0152 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 302 0154 1A46     		mov	r2, r3
 303 0156 3B69     		ldr	r3, [r7, #16]
 304 0158 1344     		add	r3, r3, r2
 305 015a 3B61     		str	r3, [r7, #16]
  99:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 306              		.loc 1 99 0
 307 015c 7B69     		ldr	r3, [r7, #20]
 308 015e 1F33     		adds	r3, r3, #31
 309 0160 C3F30903 		ubfx	r3, r3, #0, #10
 310 0164 7A68     		ldr	r2, [r7, #4]
 311 0166 1344     		add	r3, r3, r2
 312 0168 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 313 016a 1A46     		mov	r2, r3
 314 016c 3B69     		ldr	r3, [r7, #16]
 315 016e 1344     		add	r3, r3, r2
 316 0170 3B61     		str	r3, [r7, #16]
 100:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 317              		.loc 1 100 0
 318 0172 7B69     		ldr	r3, [r7, #20]
 319 0174 013B     		subs	r3, r3, #1
 320 0176 C3F30903 		ubfx	r3, r3, #0, #10
 321 017a 7A68     		ldr	r2, [r7, #4]
 322 017c 1344     		add	r3, r3, r2
 323 017e 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 324 0180 1A46     		mov	r2, r3
 325 0182 3B69     		ldr	r3, [r7, #16]
 326 0184 1344     		add	r3, r3, r2
 327 0186 3B61     		str	r3, [r7, #16]
 101:gol_benchmark.c **** 
 102:gol_benchmark.c ****         cell_state = old_world[base_cell];
 328              		.loc 1 102 0
 329 0188 7A68     		ldr	r2, [r7, #4]
 330 018a 7B69     		ldr	r3, [r7, #20]
 331 018c 1344     		add	r3, r3, r2
 332 018e 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 333 0190 FB60     		str	r3, [r7, #12]
 103:gol_benchmark.c ****         if (cell_state == DEAD) {
 334              		.loc 1 103 0
 335 0192 FB68     		ldr	r3, [r7, #12]
 336 0194 002B     		cmp	r3, #0
 337 0196 0ED1     		bne	.L17
 104:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 338              		.loc 1 104 0
 339 0198 3B69     		ldr	r3, [r7, #16]
 340 019a 032B     		cmp	r3, #3
 341 019c 05D1     		bne	.L18
 105:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 342              		.loc 1 105 0
 343 019e 3A68     		ldr	r2, [r7]
 344 01a0 7B69     		ldr	r3, [r7, #20]
 345 01a2 1344     		add	r3, r3, r2
 346 01a4 0122     		movs	r2, #1
 347 01a6 1A70     		strb	r2, [r3]
 348 01a8 16E0     		b	.L20
 349              	.L18:
 106:gol_benchmark.c ****             else
 107:gol_benchmark.c ****                 new_world[base_cell] = DEAD;
 350              		.loc 1 107 0
 351 01aa 3A68     		ldr	r2, [r7]
 352 01ac 7B69     		ldr	r3, [r7, #20]
 353 01ae 1344     		add	r3, r3, r2
 354 01b0 0022     		movs	r2, #0
 355 01b2 1A70     		strb	r2, [r3]
 356 01b4 10E0     		b	.L20
 357              	.L17:
 108:gol_benchmark.c ****         } else { /*cell has been alive*/
 109:gol_benchmark.c ****             if ((living_adjacents == 2) || (living_adjacents == 3))
 358              		.loc 1 109 0
 359 01b6 3B69     		ldr	r3, [r7, #16]
 360 01b8 022B     		cmp	r3, #2
 361 01ba 02D0     		beq	.L21
 362              		.loc 1 109 0 is_stmt 0 discriminator 1
 363 01bc 3B69     		ldr	r3, [r7, #16]
 364 01be 032B     		cmp	r3, #3
 365 01c0 05D1     		bne	.L22
 366              	.L21:
 110:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 367              		.loc 1 110 0 is_stmt 1
 368 01c2 3A68     		ldr	r2, [r7]
 369 01c4 7B69     		ldr	r3, [r7, #20]
 370 01c6 1344     		add	r3, r3, r2
 371 01c8 0122     		movs	r2, #1
 372 01ca 1A70     		strb	r2, [r3]
 373 01cc 04E0     		b	.L20
 374              	.L22:
 111:gol_benchmark.c ****             else
 112:gol_benchmark.c ****                 new_world[base_cell] = DEAD; /*cell dies*/
 375              		.loc 1 112 0
 376 01ce 3A68     		ldr	r2, [r7]
 377 01d0 7B69     		ldr	r3, [r7, #20]
 378 01d2 1344     		add	r3, r3, r2
 379 01d4 0022     		movs	r2, #0
 380 01d6 1A70     		strb	r2, [r3]
 381              	.L20:
 382              	.LBE2:
  89:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
 383              		.loc 1 89 0 discriminator 2
 384 01d8 7B69     		ldr	r3, [r7, #20]
 385 01da 013B     		subs	r3, r3, #1
 386 01dc 7B61     		str	r3, [r7, #20]
 387              	.L16:
  89:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
 388              		.loc 1 89 0 is_stmt 0 discriminator 1
 389 01de 7B69     		ldr	r3, [r7, #20]
 390 01e0 002B     		cmp	r3, #0
 391 01e2 7FF47CAF 		bne	.L23
 113:gol_benchmark.c ****         }
 114:gol_benchmark.c ****     }
 115:gol_benchmark.c **** }
 392              		.loc 1 115 0 is_stmt 1
 393 01e6 00BF     		nop
 394 01e8 1C37     		adds	r7, r7, #28
 395              		.cfi_def_cfa_offset 4
 396 01ea BD46     		mov	sp, r7
 397              		.cfi_def_cfa_register 13
 398              		@ sp needed
 399 01ec 80BC     		pop	{r7}
 400              		.cfi_restore 7
 401              		.cfi_def_cfa_offset 0
 402 01ee 7047     		bx	lr
 403              		.cfi_endproc
 404              	.LFE3:
 406              		.align	2
 407              		.thumb
 408              		.thumb_func
 410              	Gol_Iteration_32:
 411              	.LFB4:
 116:gol_benchmark.c **** 
 117:gol_benchmark.c **** static void Gol_Iteration_32(const INT32 *old_world, INT32 *new_world) {
 412              		.loc 1 117 0
 413              		.cfi_startproc
 414              		@ args = 0, pretend = 0, frame = 24
 415              		@ frame_needed = 1, uses_anonymous_args = 0
 416              		@ link register save eliminated.
 417 01f0 80B4     		push	{r7}
 418              		.cfi_def_cfa_offset 4
 419              		.cfi_offset 7, -4
 420 01f2 87B0     		sub	sp, sp, #28
 421              		.cfi_def_cfa_offset 32
 422 01f4 00AF     		add	r7, sp, #0
 423              		.cfi_def_cfa_register 7
 424 01f6 7860     		str	r0, [r7, #4]
 425 01f8 3960     		str	r1, [r7]
 118:gol_benchmark.c ****     uint32_t base_cell;
 119:gol_benchmark.c ****     /*some simplifications here to avoid benchmarking the loop overhead
 120:gol_benchmark.c ****       or the wrapping.
 121:gol_benchmark.c ****       cell 0 is not updated, and the wrapping is strange, but it doesn't
 122:gol_benchmark.c ****       matter for benchmarking.*/
 123:gol_benchmark.c ****     for (base_cell = ROWS * COLS - 1UL; base_cell != 0; base_cell--) {
 426              		.loc 1 123 0
 427 01fa 40F2FF33 		movw	r3, #1023
 428 01fe 7B61     		str	r3, [r7, #20]
 429 0200 85E0     		b	.L25
 430              	.L32:
 431              	.LBB3:
 124:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 125:gol_benchmark.c **** 
 126:gol_benchmark.c ****         /*counting from upper left adjacent, clockwise*/
 127:gol_benchmark.c ****         living_adjacents  = old_world[(base_cell - COLS - 1UL) & WRAP_MASK];
 432              		.loc 1 127 0
 433 0202 7B69     		ldr	r3, [r7, #20]
 434 0204 213B     		subs	r3, r3, #33
 435 0206 C3F30903 		ubfx	r3, r3, #0, #10
 436 020a 9B00     		lsls	r3, r3, #2
 437 020c 7A68     		ldr	r2, [r7, #4]
 438 020e 1344     		add	r3, r3, r2
 439 0210 1B68     		ldr	r3, [r3]
 440 0212 3B61     		str	r3, [r7, #16]
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 441              		.loc 1 128 0
 442 0214 7B69     		ldr	r3, [r7, #20]
 443 0216 203B     		subs	r3, r3, #32
 444 0218 C3F30903 		ubfx	r3, r3, #0, #10
 445 021c 9B00     		lsls	r3, r3, #2
 446 021e 7A68     		ldr	r2, [r7, #4]
 447 0220 1344     		add	r3, r3, r2
 448 0222 1B68     		ldr	r3, [r3]
 449 0224 3A69     		ldr	r2, [r7, #16]
 450 0226 1344     		add	r3, r3, r2
 451 0228 3B61     		str	r3, [r7, #16]
 129:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 452              		.loc 1 129 0
 453 022a 7B69     		ldr	r3, [r7, #20]
 454 022c 1F3B     		subs	r3, r3, #31
 455 022e C3F30903 		ubfx	r3, r3, #0, #10
 456 0232 9B00     		lsls	r3, r3, #2
 457 0234 7A68     		ldr	r2, [r7, #4]
 458 0236 1344     		add	r3, r3, r2
 459 0238 1B68     		ldr	r3, [r3]
 460 023a 3A69     		ldr	r2, [r7, #16]
 461 023c 1344     		add	r3, r3, r2
 462 023e 3B61     		str	r3, [r7, #16]
 130:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 463              		.loc 1 130 0
 464 0240 7B69     		ldr	r3, [r7, #20]
 465 0242 0133     		adds	r3, r3, #1
 466 0244 C3F30903 		ubfx	r3, r3, #0, #10
 467 0248 9B00     		lsls	r3, r3, #2
 468 024a 7A68     		ldr	r2, [r7, #4]
 469 024c 1344     		add	r3, r3, r2
 470 024e 1B68     		ldr	r3, [r3]
 471 0250 3A69     		ldr	r2, [r7, #16]
 472 0252 1344     		add	r3, r3, r2
 473 0254 3B61     		str	r3, [r7, #16]
 131:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 474              		.loc 1 131 0
 475 0256 7B69     		ldr	r3, [r7, #20]
 476 0258 2133     		adds	r3, r3, #33
 477 025a C3F30903 		ubfx	r3, r3, #0, #10
 478 025e 9B00     		lsls	r3, r3, #2
 479 0260 7A68     		ldr	r2, [r7, #4]
 480 0262 1344     		add	r3, r3, r2
 481 0264 1B68     		ldr	r3, [r3]
 482 0266 3A69     		ldr	r2, [r7, #16]
 483 0268 1344     		add	r3, r3, r2
 484 026a 3B61     		str	r3, [r7, #16]
 132:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 485              		.loc 1 132 0
 486 026c 7B69     		ldr	r3, [r7, #20]
 487 026e 2033     		adds	r3, r3, #32
 488 0270 C3F30903 		ubfx	r3, r3, #0, #10
 489 0274 9B00     		lsls	r3, r3, #2
 490 0276 7A68     		ldr	r2, [r7, #4]
 491 0278 1344     		add	r3, r3, r2
 492 027a 1B68     		ldr	r3, [r3]
 493 027c 3A69     		ldr	r2, [r7, #16]
 494 027e 1344     		add	r3, r3, r2
 495 0280 3B61     		str	r3, [r7, #16]
 133:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 496              		.loc 1 133 0
 497 0282 7B69     		ldr	r3, [r7, #20]
 498 0284 1F33     		adds	r3, r3, #31
 499 0286 C3F30903 		ubfx	r3, r3, #0, #10
 500 028a 9B00     		lsls	r3, r3, #2
 501 028c 7A68     		ldr	r2, [r7, #4]
 502 028e 1344     		add	r3, r3, r2
 503 0290 1B68     		ldr	r3, [r3]
 504 0292 3A69     		ldr	r2, [r7, #16]
 505 0294 1344     		add	r3, r3, r2
 506 0296 3B61     		str	r3, [r7, #16]
 134:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 507              		.loc 1 134 0
 508 0298 7B69     		ldr	r3, [r7, #20]
 509 029a 013B     		subs	r3, r3, #1
 510 029c C3F30903 		ubfx	r3, r3, #0, #10
 511 02a0 9B00     		lsls	r3, r3, #2
 512 02a2 7A68     		ldr	r2, [r7, #4]
 513 02a4 1344     		add	r3, r3, r2
 514 02a6 1B68     		ldr	r3, [r3]
 515 02a8 3A69     		ldr	r2, [r7, #16]
 516 02aa 1344     		add	r3, r3, r2
 517 02ac 3B61     		str	r3, [r7, #16]
 135:gol_benchmark.c **** 
 136:gol_benchmark.c ****         cell_state = old_world[base_cell];
 518              		.loc 1 136 0
 519 02ae 7B69     		ldr	r3, [r7, #20]
 520 02b0 9B00     		lsls	r3, r3, #2
 521 02b2 7A68     		ldr	r2, [r7, #4]
 522 02b4 1344     		add	r3, r3, r2
 523 02b6 1B68     		ldr	r3, [r3]
 524 02b8 FB60     		str	r3, [r7, #12]
 137:gol_benchmark.c ****         if (cell_state == DEAD) {
 525              		.loc 1 137 0
 526 02ba FB68     		ldr	r3, [r7, #12]
 527 02bc 002B     		cmp	r3, #0
 528 02be 10D1     		bne	.L26
 138:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 529              		.loc 1 138 0
 530 02c0 3B69     		ldr	r3, [r7, #16]
 531 02c2 032B     		cmp	r3, #3
 532 02c4 06D1     		bne	.L27
 139:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 533              		.loc 1 139 0
 534 02c6 7B69     		ldr	r3, [r7, #20]
 535 02c8 9B00     		lsls	r3, r3, #2
 536 02ca 3A68     		ldr	r2, [r7]
 537 02cc 1344     		add	r3, r3, r2
 538 02ce 0122     		movs	r2, #1
 539 02d0 1A60     		str	r2, [r3]
 540 02d2 19E0     		b	.L29
 541              	.L27:
 140:gol_benchmark.c ****             else
 141:gol_benchmark.c ****                 new_world[base_cell] = DEAD;
 542              		.loc 1 141 0
 543 02d4 7B69     		ldr	r3, [r7, #20]
 544 02d6 9B00     		lsls	r3, r3, #2
 545 02d8 3A68     		ldr	r2, [r7]
 546 02da 1344     		add	r3, r3, r2
 547 02dc 0022     		movs	r2, #0
 548 02de 1A60     		str	r2, [r3]
 549 02e0 12E0     		b	.L29
 550              	.L26:
 142:gol_benchmark.c ****         } else { /*cell has been alive*/
 143:gol_benchmark.c ****             if ((living_adjacents == 2) || (living_adjacents == 3))
 551              		.loc 1 143 0
 552 02e2 3B69     		ldr	r3, [r7, #16]
 553 02e4 022B     		cmp	r3, #2
 554 02e6 02D0     		beq	.L30
 555              		.loc 1 143 0 is_stmt 0 discriminator 1
 556 02e8 3B69     		ldr	r3, [r7, #16]
 557 02ea 032B     		cmp	r3, #3
 558 02ec 06D1     		bne	.L31
 559              	.L30:
 144:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 560              		.loc 1 144 0 is_stmt 1
 561 02ee 7B69     		ldr	r3, [r7, #20]
 562 02f0 9B00     		lsls	r3, r3, #2
 563 02f2 3A68     		ldr	r2, [r7]
 564 02f4 1344     		add	r3, r3, r2
 565 02f6 0122     		movs	r2, #1
 566 02f8 1A60     		str	r2, [r3]
 567 02fa 05E0     		b	.L29
 568              	.L31:
 145:gol_benchmark.c ****             else
 146:gol_benchmark.c ****                 new_world[base_cell] = DEAD; /*cell dies*/
 569              		.loc 1 146 0
 570 02fc 7B69     		ldr	r3, [r7, #20]
 571 02fe 9B00     		lsls	r3, r3, #2
 572 0300 3A68     		ldr	r2, [r7]
 573 0302 1344     		add	r3, r3, r2
 574 0304 0022     		movs	r2, #0
 575 0306 1A60     		str	r2, [r3]
 576              	.L29:
 577              	.LBE3:
 123:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 578              		.loc 1 123 0 discriminator 2
 579 0308 7B69     		ldr	r3, [r7, #20]
 580 030a 013B     		subs	r3, r3, #1
 581 030c 7B61     		str	r3, [r7, #20]
 582              	.L25:
 123:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 583              		.loc 1 123 0 is_stmt 0 discriminator 1
 584 030e 7B69     		ldr	r3, [r7, #20]
 585 0310 002B     		cmp	r3, #0
 586 0312 7FF476AF 		bne	.L32
 147:gol_benchmark.c ****         }
 148:gol_benchmark.c ****     }
 149:gol_benchmark.c **** }
 587              		.loc 1 149 0 is_stmt 1
 588 0316 00BF     		nop
 589 0318 1C37     		adds	r7, r7, #28
 590              		.cfi_def_cfa_offset 4
 591 031a BD46     		mov	sp, r7
 592              		.cfi_def_cfa_register 13
 593              		@ sp needed
 594 031c 80BC     		pop	{r7}
 595              		.cfi_restore 7
 596              		.cfi_def_cfa_offset 0
 597 031e 7047     		bx	lr
 598              		.cfi_endproc
 599              	.LFE4:
 601              		.align	2
 602              		.global	Gol_Benchmark_8
 603              		.thumb
 604              		.thumb_func
 606              	Gol_Benchmark_8:
 607              	.LFB5:
 150:gol_benchmark.c **** 
 151:gol_benchmark.c **** /*the 8 bit benchmark API function*/
 152:gol_benchmark.c **** int32_t Gol_Benchmark_8(uint32_t num_generations) {
 608              		.loc 1 152 0
 609              		.cfi_startproc
 610              		@ args = 0, pretend = 0, frame = 32
 611              		@ frame_needed = 1, uses_anonymous_args = 0
 612 0320 80B5     		push	{r7, lr}
 613              		.cfi_def_cfa_offset 8
 614              		.cfi_offset 7, -8
 615              		.cfi_offset 14, -4
 616 0322 88B0     		sub	sp, sp, #32
 617              		.cfi_def_cfa_offset 40
 618 0324 00AF     		add	r7, sp, #0
 619              		.cfi_def_cfa_register 7
 620 0326 7860     		str	r0, [r7, #4]
 153:gol_benchmark.c ****     INT8 *old_world, *new_world;
 154:gol_benchmark.c ****     int32_t start_time, end_time;
 155:gol_benchmark.c ****     uint32_t cnt;
 156:gol_benchmark.c ****     /*set up buffers*/
 157:gol_benchmark.c ****     old_world = (INT8 *) world_0;
 621              		.loc 1 157 0
 622 0328 164B     		ldr	r3, .L37
 623 032a FB61     		str	r3, [r7, #28]
 158:gol_benchmark.c ****     new_world = (INT8 *) world_1;
 624              		.loc 1 158 0
 625 032c 164B     		ldr	r3, .L37+4
 626 032e BB61     		str	r3, [r7, #24]
 159:gol_benchmark.c ****     /*init time does not count*/
 160:gol_benchmark.c ****     Gol_Init_8(old_world);
 627              		.loc 1 160 0
 628 0330 F869     		ldr	r0, [r7, #28]
 629 0332 FFF78BFE 		bl	Gol_Init_8
 161:gol_benchmark.c ****     start_time = Get_Time();
 630              		.loc 1 161 0
 631 0336 FFF7FEFF 		bl	Get_Time
 632 033a 3861     		str	r0, [r7, #16]
 162:gol_benchmark.c **** 
 163:gol_benchmark.c ****     for (cnt = num_generations; cnt != 0; cnt--) {
 633              		.loc 1 163 0
 634 033c 7B68     		ldr	r3, [r7, #4]
 635 033e 7B61     		str	r3, [r7, #20]
 636 0340 0CE0     		b	.L34
 637              	.L35:
 638              	.LBB4:
 164:gol_benchmark.c ****         INT8 *tmp_ptr;
 165:gol_benchmark.c ****         Gol_Iteration_8(old_world, new_world);
 639              		.loc 1 165 0 discriminator 3
 640 0342 B969     		ldr	r1, [r7, #24]
 641 0344 F869     		ldr	r0, [r7, #28]
 642 0346 FFF7C1FE 		bl	Gol_Iteration_8
 166:gol_benchmark.c ****         /*switch buffers*/
 167:gol_benchmark.c ****         tmp_ptr = old_world;
 643              		.loc 1 167 0 discriminator 3
 644 034a FB69     		ldr	r3, [r7, #28]
 645 034c FB60     		str	r3, [r7, #12]
 168:gol_benchmark.c ****         old_world = new_world;
 646              		.loc 1 168 0 discriminator 3
 647 034e BB69     		ldr	r3, [r7, #24]
 648 0350 FB61     		str	r3, [r7, #28]
 169:gol_benchmark.c ****         new_world = tmp_ptr;
 649              		.loc 1 169 0 discriminator 3
 650 0352 FB68     		ldr	r3, [r7, #12]
 651 0354 BB61     		str	r3, [r7, #24]
 652              	.LBE4:
 163:gol_benchmark.c ****         INT8 *tmp_ptr;
 653              		.loc 1 163 0 discriminator 3
 654 0356 7B69     		ldr	r3, [r7, #20]
 655 0358 013B     		subs	r3, r3, #1
 656 035a 7B61     		str	r3, [r7, #20]
 657              	.L34:
 163:gol_benchmark.c ****         INT8 *tmp_ptr;
 658              		.loc 1 163 0 is_stmt 0 discriminator 1
 659 035c 7B69     		ldr	r3, [r7, #20]
 660 035e 002B     		cmp	r3, #0
 661 0360 EFD1     		bne	.L35
 170:gol_benchmark.c ****     }
 171:gol_benchmark.c **** 
 172:gol_benchmark.c ****     end_time = Get_Time();
 662              		.loc 1 172 0 is_stmt 1
 663 0362 FFF7FEFF 		bl	Get_Time
 664 0366 B860     		str	r0, [r7, #8]
 173:gol_benchmark.c ****     prevent_compiler_opt = old_world[ROWS * COLS / 2UL];
 665              		.loc 1 173 0
 666 0368 FB69     		ldr	r3, [r7, #28]
 667 036a 03F50073 		add	r3, r3, #512
 668 036e 1B78     		ldrb	r3, [r3]	@ zero_extendqisi2
 669 0370 1A46     		mov	r2, r3
 670 0372 064B     		ldr	r3, .L37+8
 671 0374 1A60     		str	r2, [r3]
 174:gol_benchmark.c ****     return(end_time - start_time);
 672              		.loc 1 174 0
 673 0376 BA68     		ldr	r2, [r7, #8]
 674 0378 3B69     		ldr	r3, [r7, #16]
 675 037a D31A     		subs	r3, r2, r3
 175:gol_benchmark.c **** }
 676              		.loc 1 175 0
 677 037c 1846     		mov	r0, r3
 678 037e 2037     		adds	r7, r7, #32
 679              		.cfi_def_cfa_offset 8
 680 0380 BD46     		mov	sp, r7
 681              		.cfi_def_cfa_register 13
 682              		@ sp needed
 683 0382 80BD     		pop	{r7, pc}
 684              	.L38:
 685              		.align	2
 686              	.L37:
 687 0384 00000000 		.word	world_0
 688 0388 00100000 		.word	world_1
 689 038c 00000000 		.word	prevent_compiler_opt
 690              		.cfi_endproc
 691              	.LFE5:
 693              		.align	2
 694              		.global	Gol_Benchmark_32
 695              		.thumb
 696              		.thumb_func
 698              	Gol_Benchmark_32:
 699              	.LFB6:
 176:gol_benchmark.c **** 
 177:gol_benchmark.c **** /*the 32 bit benchmark API function*/
 178:gol_benchmark.c **** int32_t Gol_Benchmark_32(uint32_t num_generations) {
 700              		.loc 1 178 0
 701              		.cfi_startproc
 702              		@ args = 0, pretend = 0, frame = 32
 703              		@ frame_needed = 1, uses_anonymous_args = 0
 704 0390 80B5     		push	{r7, lr}
 705              		.cfi_def_cfa_offset 8
 706              		.cfi_offset 7, -8
 707              		.cfi_offset 14, -4
 708 0392 88B0     		sub	sp, sp, #32
 709              		.cfi_def_cfa_offset 40
 710 0394 00AF     		add	r7, sp, #0
 711              		.cfi_def_cfa_register 7
 712 0396 7860     		str	r0, [r7, #4]
 179:gol_benchmark.c ****     INT32 *old_world, *new_world;
 180:gol_benchmark.c ****     int32_t start_time, end_time;
 181:gol_benchmark.c ****     uint32_t cnt;
 182:gol_benchmark.c ****     /*set up buffers*/
 183:gol_benchmark.c ****     old_world = world_0;
 713              		.loc 1 183 0
 714 0398 154B     		ldr	r3, .L43
 715 039a FB61     		str	r3, [r7, #28]
 184:gol_benchmark.c ****     new_world = world_1;
 716              		.loc 1 184 0
 717 039c 154B     		ldr	r3, .L43+4
 718 039e BB61     		str	r3, [r7, #24]
 185:gol_benchmark.c ****     /*init time does not count*/
 186:gol_benchmark.c ****     Gol_Init_32(old_world);
 719              		.loc 1 186 0
 720 03a0 F869     		ldr	r0, [r7, #28]
 721 03a2 FFF773FE 		bl	Gol_Init_32
 187:gol_benchmark.c ****     start_time = Get_Time();
 722              		.loc 1 187 0
 723 03a6 FFF7FEFF 		bl	Get_Time
 724 03aa 3861     		str	r0, [r7, #16]
 188:gol_benchmark.c **** 
 189:gol_benchmark.c ****     for (cnt = num_generations; cnt != 0; cnt--) {
 725              		.loc 1 189 0
 726 03ac 7B68     		ldr	r3, [r7, #4]
 727 03ae 7B61     		str	r3, [r7, #20]
 728 03b0 0CE0     		b	.L40
 729              	.L41:
 730              	.LBB5:
 190:gol_benchmark.c ****         INT32 *tmp_ptr;
 191:gol_benchmark.c ****         Gol_Iteration_32(old_world, new_world);
 731              		.loc 1 191 0 discriminator 3
 732 03b2 B969     		ldr	r1, [r7, #24]
 733 03b4 F869     		ldr	r0, [r7, #28]
 734 03b6 FFF71BFF 		bl	Gol_Iteration_32
 192:gol_benchmark.c ****         /*switch buffers*/
 193:gol_benchmark.c ****         tmp_ptr = old_world;
 735              		.loc 1 193 0 discriminator 3
 736 03ba FB69     		ldr	r3, [r7, #28]
 737 03bc FB60     		str	r3, [r7, #12]
 194:gol_benchmark.c ****         old_world = new_world;
 738              		.loc 1 194 0 discriminator 3
 739 03be BB69     		ldr	r3, [r7, #24]
 740 03c0 FB61     		str	r3, [r7, #28]
 195:gol_benchmark.c ****         new_world = tmp_ptr;
 741              		.loc 1 195 0 discriminator 3
 742 03c2 FB68     		ldr	r3, [r7, #12]
 743 03c4 BB61     		str	r3, [r7, #24]
 744              	.LBE5:
 189:gol_benchmark.c ****         INT32 *tmp_ptr;
 745              		.loc 1 189 0 discriminator 3
 746 03c6 7B69     		ldr	r3, [r7, #20]
 747 03c8 013B     		subs	r3, r3, #1
 748 03ca 7B61     		str	r3, [r7, #20]
 749              	.L40:
 189:gol_benchmark.c ****         INT32 *tmp_ptr;
 750              		.loc 1 189 0 is_stmt 0 discriminator 1
 751 03cc 7B69     		ldr	r3, [r7, #20]
 752 03ce 002B     		cmp	r3, #0
 753 03d0 EFD1     		bne	.L41
 196:gol_benchmark.c ****     }
 197:gol_benchmark.c **** 
 198:gol_benchmark.c ****     end_time = Get_Time();
 754              		.loc 1 198 0 is_stmt 1
 755 03d2 FFF7FEFF 		bl	Get_Time
 756 03d6 B860     		str	r0, [r7, #8]
 199:gol_benchmark.c ****     prevent_compiler_opt = old_world[ROWS * COLS / 2UL];
 757              		.loc 1 199 0
 758 03d8 FB69     		ldr	r3, [r7, #28]
 759 03da D3F80038 		ldr	r3, [r3, #2048]
 760 03de 064A     		ldr	r2, .L43+8
 761 03e0 1360     		str	r3, [r2]
 200:gol_benchmark.c ****     return(end_time - start_time);
 762              		.loc 1 200 0
 763 03e2 BA68     		ldr	r2, [r7, #8]
 764 03e4 3B69     		ldr	r3, [r7, #16]
 765 03e6 D31A     		subs	r3, r2, r3
 201:gol_benchmark.c **** }
 766              		.loc 1 201 0
 767 03e8 1846     		mov	r0, r3
 768 03ea 2037     		adds	r7, r7, #32
 769              		.cfi_def_cfa_offset 8
 770 03ec BD46     		mov	sp, r7
 771              		.cfi_def_cfa_register 13
 772              		@ sp needed
 773 03ee 80BD     		pop	{r7, pc}
 774              	.L44:
 775              		.align	2
 776              	.L43:
 777 03f0 00000000 		.word	world_0
 778 03f4 00100000 		.word	world_1
 779 03f8 00000000 		.word	prevent_compiler_opt
 780              		.cfi_endproc
 781              	.LFE6:
 783              	.Letext0:
 784              		.file 2 "c:\\gcc\\arm-none-eabi\\include\\machine\\_default_types.h"
 785              		.file 3 "c:\\gcc\\arm-none-eabi\\include\\sys\\_stdint.h"
