   1              		.syntax unified
   2              		.cpu cortex-m4
   3              		.fpu softvfp
   4              		.eabi_attribute 20, 1
   5              		.eabi_attribute 21, 1
   6              		.eabi_attribute 23, 3
   7              		.eabi_attribute 24, 1
   8              		.eabi_attribute 25, 1
   9              		.eabi_attribute 26, 1
  10              		.eabi_attribute 30, 2
  11              		.eabi_attribute 34, 1
  12              		.eabi_attribute 18, 4
  13              		.thumb
  14              		.syntax unified
  15              		.file	"gol_benchmark.c"
  16              		.text
  17              	.Ltext0:
  18              		.cfi_sections	.debug_frame
  19              		.align	2
  20              		.global	Gol_Benchmark_8
  21              		.thumb
  22              		.thumb_func
  24              	Gol_Benchmark_8:
  25              	.LFB5:
  26              		.file 1 "gol_benchmark.c"
   1:gol_benchmark.c **** /*************************************************************************
   2:gol_benchmark.c **** "Conway's Game of Life" benchmark for 8 bit and 32 bit data types.
   3:gol_benchmark.c **** The calculations start with a pseudo-random, but reproducible world. The
   4:gol_benchmark.c **** calculations are identical in every benchmark call with the same number
   5:gol_benchmark.c **** of generations.
   6:gol_benchmark.c **** 
   7:gol_benchmark.c **** resource requirements:
   8:gol_benchmark.c **** needs about 8 kB RAM for the "game of life" worlds at 32x32 cells.
   9:gol_benchmark.c **** 
  10:gol_benchmark.c **** external requirements:
  11:gol_benchmark.c **** needs the following get-time function:
  12:gol_benchmark.c **** int32_t Get_Time(void);
  13:gol_benchmark.c **** 
  14:gol_benchmark.c **** benchmark functions:
  15:gol_benchmark.c **** int32_t Gol_Benchmark_8(uint32_t num_generations);
  16:gol_benchmark.c **** int32_t Gol_Benchmark_32(uint32_t num_generations);
  17:gol_benchmark.c **** 
  18:gol_benchmark.c **** input:        desired number of generations.
  19:gol_benchmark.c **** 
  20:gol_benchmark.c **** output:       difference between Get_Time() at start and end, in whatever
  21:gol_benchmark.c ****               unit the Get_Time() function is using. The initialization
  22:gol_benchmark.c ****               is not part of the benchmark.
  23:gol_benchmark.c **** 
  24:gol_benchmark.c **** side effects: the volatile global variable "prevent_compiler_opt" is set
  25:gol_benchmark.c ****               to the final state of the middle "game of life" cell. This
  26:gol_benchmark.c ****               keeps the compiler from optimizing the benchmark away.
  27:gol_benchmark.c **** 
  28:gol_benchmark.c **** limitations:  cell 0 is not updated, and the border wrapping is strange,
  29:gol_benchmark.c ****               but it doesn't matter for benchmarking.
  30:gol_benchmark.c **** *************************************************************************/
  31:gol_benchmark.c **** 
  32:gol_benchmark.c **** #include <stdint.h>
  33:gol_benchmark.c **** 
  34:gol_benchmark.c **** #define SIGNED_TEST
  35:gol_benchmark.c **** 
  36:gol_benchmark.c **** #ifdef SIGNED_TEST
  37:gol_benchmark.c ****     #define INT8 int8_t
  38:gol_benchmark.c ****     #define INT32 int32_t
  39:gol_benchmark.c **** #else
  40:gol_benchmark.c ****     #define INT8 uint8_t
  41:gol_benchmark.c ****     #define INT32 uint32_t
  42:gol_benchmark.c **** #endif
  43:gol_benchmark.c **** 
  44:gol_benchmark.c **** #define DEAD      0
  45:gol_benchmark.c **** #define ALIVE     1U
  46:gol_benchmark.c **** 
  47:gol_benchmark.c **** /*must be powers of 2*/
  48:gol_benchmark.c **** #define ROWS      32UL
  49:gol_benchmark.c **** #define COLS      32UL
  50:gol_benchmark.c **** 
  51:gol_benchmark.c **** #define WRAP_MASK (ROWS * COLS - 1UL)
  52:gol_benchmark.c **** 
  53:gol_benchmark.c **** extern int32_t Get_Time(void);
  54:gol_benchmark.c **** 
  55:gol_benchmark.c **** volatile INT32 prevent_compiler_opt;
  56:gol_benchmark.c **** 
  57:gol_benchmark.c **** /*reuse the worlds for the 8 bit test via pointer casting*/
  58:gol_benchmark.c **** static INT32 world_0[ROWS * COLS];
  59:gol_benchmark.c **** static INT32 world_1[ROWS * COLS];
  60:gol_benchmark.c **** 
  61:gol_benchmark.c **** static uint32_t rand_state;
  62:gol_benchmark.c **** 
  63:gol_benchmark.c **** static uint32_t Random(uint32_t max_val) {
  64:gol_benchmark.c ****     rand_state *= 1103515245UL;
  65:gol_benchmark.c ****     rand_state += 12345UL;
  66:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
  67:gol_benchmark.c **** }
  68:gol_benchmark.c **** 
  69:gol_benchmark.c **** static void Gol_Init_8(INT8 *world_8) {
  70:gol_benchmark.c ****     uint32_t cnt;
  71:gol_benchmark.c ****     rand_state = 42UL; /*pseudo-random, reproducible init*/
  72:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
  73:gol_benchmark.c ****         world_8[cnt] = (INT8) Random(ALIVE+1UL);
  74:gol_benchmark.c **** }
  75:gol_benchmark.c **** 
  76:gol_benchmark.c **** static void Gol_Init_32(INT32 *world_32) {
  77:gol_benchmark.c ****     uint32_t cnt;
  78:gol_benchmark.c ****     rand_state = 42UL; /*pseudo-random, reproducible init*/
  79:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
  80:gol_benchmark.c ****         world_32[cnt] = (INT32) Random(ALIVE+1UL);
  81:gol_benchmark.c **** }
  82:gol_benchmark.c **** 
  83:gol_benchmark.c **** static void Gol_Iteration_8(const INT8 *old_world, INT8 *new_world) {
  84:gol_benchmark.c ****     uint32_t base_cell;
  85:gol_benchmark.c ****     /*some simplifications here to avoid benchmarking the loop overhead
  86:gol_benchmark.c ****       or the wrapping.
  87:gol_benchmark.c ****       cell 0 is not updated, and the wrapping is strange, but it doesn't
  88:gol_benchmark.c ****       matter for benchmarking.*/
  89:gol_benchmark.c ****     for (base_cell = ROWS * COLS - 1UL; base_cell != 0; base_cell--) {
  90:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
  91:gol_benchmark.c **** 
  92:gol_benchmark.c ****         /*counting from upper left adjacent, clockwise*/
  93:gol_benchmark.c ****         living_adjacents  = old_world[(base_cell - COLS - 1UL) & WRAP_MASK];
  94:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
  95:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
  96:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
  97:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
  98:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
  99:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 100:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 101:gol_benchmark.c **** 
 102:gol_benchmark.c ****         cell_state = old_world[base_cell];
 103:gol_benchmark.c ****         if (cell_state == DEAD) {
 104:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 105:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 106:gol_benchmark.c ****             else
 107:gol_benchmark.c ****                 new_world[base_cell] = DEAD;
 108:gol_benchmark.c ****         } else { /*cell has been alive*/
 109:gol_benchmark.c ****             if ((living_adjacents == 2) || (living_adjacents == 3))
 110:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 111:gol_benchmark.c ****             else
 112:gol_benchmark.c ****                 new_world[base_cell] = DEAD; /*cell dies*/
 113:gol_benchmark.c ****         }
 114:gol_benchmark.c ****     }
 115:gol_benchmark.c **** }
 116:gol_benchmark.c **** 
 117:gol_benchmark.c **** static void Gol_Iteration_32(const INT32 *old_world, INT32 *new_world) {
 118:gol_benchmark.c ****     uint32_t base_cell;
 119:gol_benchmark.c ****     /*some simplifications here to avoid benchmarking the loop overhead
 120:gol_benchmark.c ****       or the wrapping.
 121:gol_benchmark.c ****       cell 0 is not updated, and the wrapping is strange, but it doesn't
 122:gol_benchmark.c ****       matter for benchmarking.*/
 123:gol_benchmark.c ****     for (base_cell = ROWS * COLS - 1UL; base_cell != 0; base_cell--) {
 124:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 125:gol_benchmark.c **** 
 126:gol_benchmark.c ****         /*counting from upper left adjacent, clockwise*/
 127:gol_benchmark.c ****         living_adjacents  = old_world[(base_cell - COLS - 1UL) & WRAP_MASK];
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 129:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 130:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 131:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 132:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 133:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 134:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 135:gol_benchmark.c **** 
 136:gol_benchmark.c ****         cell_state = old_world[base_cell];
 137:gol_benchmark.c ****         if (cell_state == DEAD) {
 138:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 139:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 140:gol_benchmark.c ****             else
 141:gol_benchmark.c ****                 new_world[base_cell] = DEAD;
 142:gol_benchmark.c ****         } else { /*cell has been alive*/
 143:gol_benchmark.c ****             if ((living_adjacents == 2) || (living_adjacents == 3))
 144:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 145:gol_benchmark.c ****             else
 146:gol_benchmark.c ****                 new_world[base_cell] = DEAD; /*cell dies*/
 147:gol_benchmark.c ****         }
 148:gol_benchmark.c ****     }
 149:gol_benchmark.c **** }
 150:gol_benchmark.c **** 
 151:gol_benchmark.c **** /*the 8 bit benchmark API function*/
 152:gol_benchmark.c **** int32_t Gol_Benchmark_8(uint32_t num_generations) {
  27              		.loc 1 152 0
  28              		.cfi_startproc
  29              		@ args = 0, pretend = 0, frame = 8
  30              		@ frame_needed = 0, uses_anonymous_args = 0
  31              	.LVL0:
  32 0000 2DE9F04F 		push	{r4, r5, r6, r7, r8, r9, r10, fp, lr}
  33              		.cfi_def_cfa_offset 36
  34              		.cfi_offset 4, -36
  35              		.cfi_offset 5, -32
  36              		.cfi_offset 6, -28
  37              		.cfi_offset 7, -24
  38              		.cfi_offset 8, -20
  39              		.cfi_offset 9, -16
  40              		.cfi_offset 10, -12
  41              		.cfi_offset 11, -8
  42              		.cfi_offset 14, -4
  43 0004 424A     		ldr	r2, .L19
  44              	.LBB24:
  45              	.LBB25:
  46              	.LBB26:
  47              	.LBB27:
  65:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
  48              		.loc 1 65 0
  49 0006 434C     		ldr	r4, .L19+4
  50              	.LBE27:
  51              	.LBE26:
  52              	.LBE25:
  53              	.LBE24:
  54              		.loc 1 152 0
  55 0008 83B0     		sub	sp, sp, #12
  56              		.cfi_def_cfa_offset 48
  57              		.loc 1 152 0
  58 000a 2A23     		movs	r3, #42
  59 000c 0190     		str	r0, [sp, #4]
  60 000e 02F58060 		add	r0, r2, #1024
  61              	.LVL1:
  62              	.L2:
  63              	.LBB31:
  64              	.LBB30:
  65              	.LBB29:
  66              	.LBB28:
  65:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
  67              		.loc 1 65 0
  68 0012 04FB03F3 		mul	r3, r4, r3
  69 0016 03F54053 		add	r3, r3, #12288
  70 001a 3933     		adds	r3, r3, #57
  71              	.LVL2:
  72              	.LBE28:
  73              	.LBE29:
  73:gol_benchmark.c **** }
  74              		.loc 1 73 0
  75 001c C3F30041 		ubfx	r1, r3, #16, #1
  76 0020 02F8011F 		strb	r1, [r2, #1]!
  77              	.LVL3:
  72:gol_benchmark.c ****         world_8[cnt] = (INT8) Random(ALIVE+1UL);
  78              		.loc 1 72 0
  79 0024 8242     		cmp	r2, r0
  80 0026 F4D1     		bne	.L2
  81 0028 3B4F     		ldr	r7, .L19+8
  82 002a C7F8083F 		str	r3, [r7, #3848]
  83              	.LVL4:
  84              	.LBE30:
  85              	.LBE31:
 153:gol_benchmark.c ****     INT8 *old_world, *new_world;
 154:gol_benchmark.c ****     int32_t start_time, end_time;
 155:gol_benchmark.c ****     uint32_t cnt;
 156:gol_benchmark.c ****     /*set up buffers*/
 157:gol_benchmark.c ****     old_world = (INT8 *) world_0;
 158:gol_benchmark.c ****     new_world = (INT8 *) world_1;
 159:gol_benchmark.c ****     /*init time does not count*/
 160:gol_benchmark.c ****     Gol_Init_8(old_world);
 161:gol_benchmark.c ****     start_time = Get_Time();
  86              		.loc 1 161 0
  87 002e FFF7FEFF 		bl	Get_Time
  88              	.LVL5:
 162:gol_benchmark.c **** 
 163:gol_benchmark.c ****     for (cnt = num_generations; cnt != 0; cnt--) {
  89              		.loc 1 163 0
  90 0032 019B     		ldr	r3, [sp, #4]
 161:gol_benchmark.c **** 
  91              		.loc 1 161 0
  92 0034 8046     		mov	r8, r0
  93              	.LVL6:
  94              		.loc 1 163 0
  95 0036 002B     		cmp	r3, #0
  96 0038 5DD0     		beq	.L10
  97 003a A7F1F800 		sub	r0, r7, #248
  98              	.LVL7:
  99 003e 374F     		ldr	r7, .L19+12
 100              	.LBB32:
 101              	.LBB33:
 102              	.LBB34:
 103              	.LBB35:
 112:gol_benchmark.c ****         }
 104              		.loc 1 112 0
 105 0040 4FF0000C 		mov	ip, #0
 110:gol_benchmark.c ****             else
 106              		.loc 1 110 0
 107 0044 4FF00109 		mov	r9, #1
 108              	.LVL8:
 109              	.L9:
 110 0048 00F2FF34 		addw	r4, r0, #1023
 111 004c 07F2FF35 		addw	r5, r7, #1023
 112              	.LBE35:
 113              	.LBE34:
 114              	.LBE33:
 115              	.LBE32:
 116 0050 40F2DE31 		movw	r1, #990
 117 0054 08E0     		b	.L8
 118              	.LVL9:
 119              	.L18:
 120              	.LBB44:
 121              	.LBB42:
 122              	.LBB40:
 123              	.LBB36:
 104:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 124              		.loc 1 104 0
 125 0056 032B     		cmp	r3, #3
 126 0058 4AD0     		beq	.L15
 107:gol_benchmark.c ****         } else { /*cell has been alive*/
 127              		.loc 1 107 0
 128 005a 2E70     		strb	r6, [r5]
 129              	.L6:
 130              	.LVL10:
 131 005c 0139     		subs	r1, r1, #1
 132              	.LVL11:
 133              	.LBE36:
  89:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
 134              		.loc 1 89 0
 135 005e 11F1210F 		cmn	r1, #33
 136 0062 05F1FF35 		add	r5, r5, #-1
 137 0066 3BD0     		beq	.L17
 138              	.LVL12:
 139              	.L8:
 140              	.LBB37:
  94:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 141              		.loc 1 94 0
 142 0068 01F1010A 		add	r10, r1, #1
 143 006c CAF3090A 		ubfx	r10, r10, #0, #10
  93:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 144              		.loc 1 93 0
 145 0070 C1F30902 		ubfx	r2, r1, #0, #10
  95:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 146              		.loc 1 95 0
 147 0074 8B1C     		adds	r3, r1, #2
 148 0076 C3F30903 		ubfx	r3, r3, #0, #10
  96:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 149              		.loc 1 96 0
 150 007a 01F1220E 		add	lr, r1, #34
  94:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 151              		.loc 1 94 0
 152 007e 10F90AB0 		ldrsb	fp, [r0, r10]
  93:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 153              		.loc 1 93 0
 154 0082 8256     		ldrsb	r2, [r0, r2]
 155              	.LVL13:
  95:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 156              		.loc 1 95 0
 157 0084 C356     		ldrsb	r3, [r0, r3]
 100:gol_benchmark.c **** 
 158              		.loc 1 100 0
 159 0086 14F901AD 		ldrsb	r10, [r4, #-1]!
  96:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 160              		.loc 1 96 0
 161 008a CEF3090E 		ubfx	lr, lr, #0, #10
  94:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 162              		.loc 1 94 0
 163 008e 9344     		add	fp, fp, r2
 164              	.LVL14:
  96:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 165              		.loc 1 96 0
 166 0090 10F90EE0 		ldrsb	lr, [r0, lr]
 103:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 167              		.loc 1 103 0
 168 0094 94F90160 		ldrsb	r6, [r4, #1]
  97:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 169              		.loc 1 97 0
 170 0098 01F14202 		add	r2, r1, #66
  95:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 171              		.loc 1 95 0
 172 009c 9B44     		add	fp, fp, r3
 173              	.LVL15:
  97:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 174              		.loc 1 97 0
 175 009e C2F30902 		ubfx	r2, r2, #0, #10
  98:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 176              		.loc 1 98 0
 177 00a2 01F14103 		add	r3, r1, #65
  96:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 178              		.loc 1 96 0
 179 00a6 DE44     		add	lr, lr, fp
 180              	.LVL16:
  98:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 181              		.loc 1 98 0
 182 00a8 C3F30903 		ubfx	r3, r3, #0, #10
  99:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 183              		.loc 1 99 0
 184 00ac 01F1400B 		add	fp, r1, #64
  97:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 185              		.loc 1 97 0
 186 00b0 8256     		ldrsb	r2, [r0, r2]
  98:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 187              		.loc 1 98 0
 188 00b2 C356     		ldrsb	r3, [r0, r3]
  99:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 189              		.loc 1 99 0
 190 00b4 CBF3090B 		ubfx	fp, fp, #0, #10
  97:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 191              		.loc 1 97 0
 192 00b8 7244     		add	r2, r2, lr
 193              	.LVL17:
  99:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 194              		.loc 1 99 0
 195 00ba 10F90BB0 		ldrsb	fp, [r0, fp]
  98:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 196              		.loc 1 98 0
 197 00be 1A44     		add	r2, r2, r3
 198              	.LVL18:
  99:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 199              		.loc 1 99 0
 200 00c0 0BEB0203 		add	r3, fp, r2
 201              	.LVL19:
 100:gol_benchmark.c **** 
 202              		.loc 1 100 0
 203 00c4 5344     		add	r3, r3, r10
 204              	.LVL20:
 109:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 205              		.loc 1 109 0
 206 00c6 9A1E     		subs	r2, r3, #2
 103:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 207              		.loc 1 103 0
 208 00c8 002E     		cmp	r6, #0
 209 00ca C4D0     		beq	.L18
 109:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 210              		.loc 1 109 0
 211 00cc 012A     		cmp	r2, #1
 212 00ce 0FD9     		bls	.L15
 213 00d0 0139     		subs	r1, r1, #1
 214              	.LVL21:
 215              	.LBE37:
  89:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
 216              		.loc 1 89 0
 217 00d2 11F1210F 		cmn	r1, #33
 218              	.LBB38:
 112:gol_benchmark.c ****         }
 219              		.loc 1 112 0
 220 00d6 85F800C0 		strb	ip, [r5]
 221              	.LVL22:
 222 00da 05F1FF35 		add	r5, r5, #-1
 223              	.LBE38:
  89:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
 224              		.loc 1 89 0
 225 00de C3D1     		bne	.L8
 226              	.L17:
 227              	.LVL23:
 228              	.LBE40:
 229              	.LBE42:
 230              	.LBE44:
 231              		.loc 1 163 0 discriminator 3
 232 00e0 019B     		ldr	r3, [sp, #4]
 233 00e2 013B     		subs	r3, r3, #1
 234              	.LVL24:
 235 00e4 0193     		str	r3, [sp, #4]
 236 00e6 07D0     		beq	.L3
 237 00e8 0346     		mov	r3, r0
 238              	.LVL25:
 239 00ea 3846     		mov	r0, r7
 240              	.LVL26:
 241 00ec 1F46     		mov	r7, r3
 242              	.LVL27:
 243 00ee ABE7     		b	.L9
 244              	.LVL28:
 245              	.L15:
 246              	.LBB45:
 247              	.LBB43:
 248              	.LBB41:
 249              	.LBB39:
 110:gol_benchmark.c ****             else
 250              		.loc 1 110 0
 251 00f0 85F80090 		strb	r9, [r5]
 252 00f4 B2E7     		b	.L6
 253              	.LVL29:
 254              	.L10:
 255              	.LBE39:
 256              	.LBE41:
 257              	.LBE43:
 258              	.LBE45:
 157:gol_benchmark.c ****     new_world = (INT8 *) world_1;
 259              		.loc 1 157 0
 260 00f6 F83F     		subs	r7, r7, #248
 261              	.LVL30:
 262              	.L3:
 164:gol_benchmark.c ****         INT8 *tmp_ptr;
 165:gol_benchmark.c ****         Gol_Iteration_8(old_world, new_world);
 166:gol_benchmark.c ****         /*switch buffers*/
 167:gol_benchmark.c ****         tmp_ptr = old_world;
 168:gol_benchmark.c ****         old_world = new_world;
 169:gol_benchmark.c ****         new_world = tmp_ptr;
 170:gol_benchmark.c ****     }
 171:gol_benchmark.c **** 
 172:gol_benchmark.c ****     end_time = Get_Time();
 263              		.loc 1 172 0
 264 00f8 FFF7FEFF 		bl	Get_Time
 265              	.LVL31:
 173:gol_benchmark.c ****     prevent_compiler_opt = old_world[ROWS * COLS / 2UL];
 266              		.loc 1 173 0
 267 00fc 084B     		ldr	r3, .L19+16
 268 00fe 97F90022 		ldrsb	r2, [r7, #512]
 269 0102 1A60     		str	r2, [r3]
 174:gol_benchmark.c ****     return(end_time - start_time);
 175:gol_benchmark.c **** }
 270              		.loc 1 175 0
 271 0104 C8EB0000 		rsb	r0, r8, r0
 272              	.LVL32:
 273 0108 03B0     		add	sp, sp, #12
 274              		.cfi_def_cfa_offset 36
 275              		@ sp needed
 276 010a BDE8F08F 		pop	{r4, r5, r6, r7, r8, r9, r10, fp, pc}
 277              	.LVL33:
 278              	.L20:
 279 010e 00BF     		.align	2
 280              	.L19:
 281 0110 FF0F0000 		.word	.LANCHOR1-249
 282 0114 6D4EC641 		.word	1103515245
 283 0118 F8100000 		.word	.LANCHOR1
 284 011c 00000000 		.word	.LANCHOR0
 285 0120 00000000 		.word	prevent_compiler_opt
 286              		.cfi_endproc
 287              	.LFE5:
 289              		.align	2
 290              		.global	Gol_Benchmark_32
 291              		.thumb
 292              		.thumb_func
 294              	Gol_Benchmark_32:
 295              	.LFB6:
 176:gol_benchmark.c **** 
 177:gol_benchmark.c **** /*the 32 bit benchmark API function*/
 178:gol_benchmark.c **** int32_t Gol_Benchmark_32(uint32_t num_generations) {
 296              		.loc 1 178 0
 297              		.cfi_startproc
 298              		@ args = 0, pretend = 0, frame = 0
 299              		@ frame_needed = 0, uses_anonymous_args = 0
 300              	.LVL34:
 301 0124 434A     		ldr	r2, .L38
 302 0126 2DE9F84F 		push	{r3, r4, r5, r6, r7, r8, r9, r10, fp, lr}
 303              		.cfi_def_cfa_offset 40
 304              		.cfi_offset 3, -40
 305              		.cfi_offset 4, -36
 306              		.cfi_offset 5, -32
 307              		.cfi_offset 6, -28
 308              		.cfi_offset 7, -24
 309              		.cfi_offset 8, -20
 310              		.cfi_offset 9, -16
 311              		.cfi_offset 10, -12
 312              		.cfi_offset 11, -8
 313              		.cfi_offset 14, -4
 314              	.LBB54:
 315              	.LBB55:
 316              	.LBB56:
 317              	.LBB57:
  65:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
 318              		.loc 1 65 0
 319 012a 434C     		ldr	r4, .L38+4
 320              	.LBE57:
 321              	.LBE56:
 322              	.LBE55:
 323              	.LBE54:
 324              		.loc 1 178 0
 325 012c 8046     		mov	r8, r0
 326 012e 2A23     		movs	r3, #42
 327 0130 02F58050 		add	r0, r2, #4096
 328              	.LVL35:
 329              	.L22:
 330              	.LBB61:
 331              	.LBB60:
 332              	.LBB59:
 333              	.LBB58:
  65:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
 334              		.loc 1 65 0
 335 0134 04FB03F3 		mul	r3, r4, r3
 336 0138 03F54053 		add	r3, r3, #12288
 337 013c 3933     		adds	r3, r3, #57
 338              	.LVL36:
 339              	.LBE58:
 340              	.LBE59:
  80:gol_benchmark.c **** }
 341              		.loc 1 80 0
 342 013e C3F30041 		ubfx	r1, r3, #16, #1
 343 0142 42F8041F 		str	r1, [r2, #4]!
  79:gol_benchmark.c ****         world_32[cnt] = (INT32) Random(ALIVE+1UL);
 344              		.loc 1 79 0
 345 0146 8242     		cmp	r2, r0
 346 0148 F4D1     		bne	.L22
 347 014a 3C4C     		ldr	r4, .L38+8
 348 014c C4F8083F 		str	r3, [r4, #3848]
 349              	.LVL37:
 350              	.LBE60:
 351              	.LBE61:
 179:gol_benchmark.c ****     INT32 *old_world, *new_world;
 180:gol_benchmark.c ****     int32_t start_time, end_time;
 181:gol_benchmark.c ****     uint32_t cnt;
 182:gol_benchmark.c ****     /*set up buffers*/
 183:gol_benchmark.c ****     old_world = world_0;
 184:gol_benchmark.c ****     new_world = world_1;
 185:gol_benchmark.c ****     /*init time does not count*/
 186:gol_benchmark.c ****     Gol_Init_32(old_world);
 187:gol_benchmark.c ****     start_time = Get_Time();
 352              		.loc 1 187 0
 353 0150 FFF7FEFF 		bl	Get_Time
 354              	.LVL38:
 355 0154 8146     		mov	r9, r0
 356              	.LVL39:
 188:gol_benchmark.c **** 
 189:gol_benchmark.c ****     for (cnt = num_generations; cnt != 0; cnt--) {
 357              		.loc 1 189 0
 358 0156 B8F1000F 		cmp	r8, #0
 359 015a 5ED0     		beq	.L30
 360 015c DFF8E4B0 		ldr	fp, .L38+16
 361 0160 A4F1F800 		sub	r0, r4, #248
 362              	.LVL40:
 363              	.LBB62:
 364              	.LBB63:
 365              	.LBB64:
 366              	.LBB65:
 146:gol_benchmark.c ****         }
 367              		.loc 1 146 0
 368 0164 4FF0000A 		mov	r10, #0
 144:gol_benchmark.c ****             else
 369              		.loc 1 144 0
 370 0168 0124     		movs	r4, #1
 371              	.LVL41:
 372              	.L29:
 373 016a 00F6FC7E 		addw	lr, r0, #4092
 374 016e 00F58057 		add	r7, r0, #4096
 375 0172 0BF6FC76 		addw	r6, fp, #4092
 376              	.LBE65:
 377              	.LBE64:
 378              	.LBE63:
 379              	.LBE62:
 380 0176 40F2FF33 		movw	r3, #1023
 381 017a 06E0     		b	.L28
 382              	.LVL42:
 383              	.L37:
 384              	.LBB74:
 385              	.LBB72:
 386              	.LBB70:
 387              	.LBB66:
 138:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 388              		.loc 1 138 0
 389 017c 032A     		cmp	r2, #3
 390 017e 4AD0     		beq	.L35
 141:gol_benchmark.c ****         } else { /*cell has been alive*/
 391              		.loc 1 141 0
 392 0180 3560     		str	r5, [r6]
 393              	.L26:
 394              	.LVL43:
 395              	.LBE66:
 123:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 396              		.loc 1 123 0
 397 0182 013B     		subs	r3, r3, #1
 398              	.LVL44:
 399 0184 A6F10406 		sub	r6, r6, #4
 400 0188 3ED0     		beq	.L36
 401              	.LVL45:
 402              	.L28:
 403              	.LBB67:
 127:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 404              		.loc 1 127 0
 405 018a A3F12102 		sub	r2, r3, #33
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 406              		.loc 1 128 0
 407 018e A3F12001 		sub	r1, r3, #32
 127:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 408              		.loc 1 127 0
 409 0192 C2F30902 		ubfx	r2, r2, #0, #10
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 410              		.loc 1 128 0
 411 0196 C1F30901 		ubfx	r1, r1, #0, #10
 129:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 412              		.loc 1 129 0
 413 019a A3F11F0C 		sub	ip, r3, #31
 414 019e CCF3090C 		ubfx	ip, ip, #0, #10
 130:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 415              		.loc 1 130 0
 416 01a2 5D1C     		adds	r5, r3, #1
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 417              		.loc 1 128 0
 418 01a4 50F82110 		ldr	r1, [r0, r1, lsl #2]
 127:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 419              		.loc 1 127 0
 420 01a8 50F82220 		ldr	r2, [r0, r2, lsl #2]
 421              	.LVL46:
 129:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 422              		.loc 1 129 0
 423 01ac 50F82CC0 		ldr	ip, [r0, ip, lsl #2]
 130:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 424              		.loc 1 130 0
 425 01b0 C5F30905 		ubfx	r5, r5, #0, #10
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 426              		.loc 1 128 0
 427 01b4 0A44     		add	r2, r2, r1
 428              	.LVL47:
 130:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 429              		.loc 1 130 0
 430 01b6 50F82550 		ldr	r5, [r0, r5, lsl #2]
 131:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 431              		.loc 1 131 0
 432 01ba 03F12101 		add	r1, r3, #33
 129:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 433              		.loc 1 129 0
 434 01be 6244     		add	r2, r2, ip
 435              	.LVL48:
 131:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 436              		.loc 1 131 0
 437 01c0 C1F30901 		ubfx	r1, r1, #0, #10
 132:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 438              		.loc 1 132 0
 439 01c4 03F1200C 		add	ip, r3, #32
 130:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 440              		.loc 1 130 0
 441 01c8 1544     		add	r5, r5, r2
 442              	.LVL49:
 132:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 443              		.loc 1 132 0
 444 01ca CCF3090C 		ubfx	ip, ip, #0, #10
 133:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 445              		.loc 1 133 0
 446 01ce 03F11F02 		add	r2, r3, #31
 131:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 447              		.loc 1 131 0
 448 01d2 50F82110 		ldr	r1, [r0, r1, lsl #2]
 132:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 449              		.loc 1 132 0
 450 01d6 50F82CC0 		ldr	ip, [r0, ip, lsl #2]
 133:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 451              		.loc 1 133 0
 452 01da C2F30902 		ubfx	r2, r2, #0, #10
 131:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 453              		.loc 1 131 0
 454 01de 0D44     		add	r5, r5, r1
 455              	.LVL50:
 133:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 456              		.loc 1 133 0
 457 01e0 50F82220 		ldr	r2, [r0, r2, lsl #2]
 134:gol_benchmark.c **** 
 458              		.loc 1 134 0
 459 01e4 5EF8041D 		ldr	r1, [lr, #-4]!
 132:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 460              		.loc 1 132 0
 461 01e8 AC44     		add	ip, ip, r5
 462              	.LVL51:
 133:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 463              		.loc 1 133 0
 464 01ea 6244     		add	r2, r2, ip
 465              	.LVL52:
 137:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 466              		.loc 1 137 0
 467 01ec 57F8045D 		ldr	r5, [r7, #-4]!
 134:gol_benchmark.c **** 
 468              		.loc 1 134 0
 469 01f0 0A44     		add	r2, r2, r1
 470              	.LVL53:
 143:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 471              		.loc 1 143 0
 472 01f2 911E     		subs	r1, r2, #2
 137:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 473              		.loc 1 137 0
 474 01f4 002D     		cmp	r5, #0
 475 01f6 C1D0     		beq	.L37
 143:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 476              		.loc 1 143 0
 477 01f8 0129     		cmp	r1, #1
 478 01fa 0CD9     		bls	.L35
 479              	.LBE67:
 123:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 480              		.loc 1 123 0
 481 01fc 013B     		subs	r3, r3, #1
 482              	.LVL54:
 483              	.LBB68:
 146:gol_benchmark.c ****         }
 484              		.loc 1 146 0
 485 01fe C6F800A0 		str	r10, [r6]
 486              	.LVL55:
 487 0202 A6F10406 		sub	r6, r6, #4
 488              	.LBE68:
 123:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 489              		.loc 1 123 0
 490 0206 C0D1     		bne	.L28
 491              	.L36:
 492              	.LVL56:
 493              	.LBE70:
 494              	.LBE72:
 495              	.LBE74:
 496              		.loc 1 189 0 discriminator 3
 497 0208 B8F10108 		subs	r8, r8, #1
 498              	.LVL57:
 499 020c 07D0     		beq	.L23
 500 020e 0346     		mov	r3, r0
 501 0210 5846     		mov	r0, fp
 502              	.LVL58:
 503 0212 9B46     		mov	fp, r3
 504              	.LVL59:
 505 0214 A9E7     		b	.L29
 506              	.LVL60:
 507              	.L35:
 508              	.LBB75:
 509              	.LBB73:
 510              	.LBB71:
 511              	.LBB69:
 144:gol_benchmark.c ****             else
 512              		.loc 1 144 0
 513 0216 3460     		str	r4, [r6]
 514 0218 B3E7     		b	.L26
 515              	.LVL61:
 516              	.L30:
 517              	.LBE69:
 518              	.LBE71:
 519              	.LBE73:
 520              	.LBE75:
 183:gol_benchmark.c ****     new_world = world_1;
 521              		.loc 1 183 0
 522 021a A4F1F80B 		sub	fp, r4, #248
 523              	.LVL62:
 524              	.L23:
 190:gol_benchmark.c ****         INT32 *tmp_ptr;
 191:gol_benchmark.c ****         Gol_Iteration_32(old_world, new_world);
 192:gol_benchmark.c ****         /*switch buffers*/
 193:gol_benchmark.c ****         tmp_ptr = old_world;
 194:gol_benchmark.c ****         old_world = new_world;
 195:gol_benchmark.c ****         new_world = tmp_ptr;
 196:gol_benchmark.c ****     }
 197:gol_benchmark.c **** 
 198:gol_benchmark.c ****     end_time = Get_Time();
 525              		.loc 1 198 0
 526 021e FFF7FEFF 		bl	Get_Time
 527              	.LVL63:
 199:gol_benchmark.c ****     prevent_compiler_opt = old_world[ROWS * COLS / 2UL];
 528              		.loc 1 199 0
 529 0222 074B     		ldr	r3, .L38+12
 530 0224 DBF80028 		ldr	r2, [fp, #2048]
 531 0228 1A60     		str	r2, [r3]
 200:gol_benchmark.c ****     return(end_time - start_time);
 201:gol_benchmark.c **** }
 532              		.loc 1 201 0
 533 022a C9EB0000 		rsb	r0, r9, r0
 534              	.LVL64:
 535 022e BDE8F88F 		pop	{r3, r4, r5, r6, r7, r8, r9, r10, fp, pc}
 536              	.LVL65:
 537              	.L39:
 538 0232 00BF     		.align	2
 539              	.L38:
 540 0234 FC0F0000 		.word	.LANCHOR1-252
 541 0238 6D4EC641 		.word	1103515245
 542 023c F8100000 		.word	.LANCHOR1
 543 0240 00000000 		.word	prevent_compiler_opt
 544 0244 00000000 		.word	.LANCHOR0
 545              		.cfi_endproc
 546              	.LFE6:
 548              		.comm	prevent_compiler_opt,4,4
 549              		.bss
 550              		.align	2
 551              		.set	.LANCHOR0,. + 0
 552              		.set	.LANCHOR1,. + 4344
 555              	world_1:
 556 0000 00000000 		.space	4096
 556      00000000 
 556      00000000 
 556      00000000 
 556      00000000 
 559              	world_0:
 560 1000 00000000 		.space	4096
 560      00000000 
 560      00000000 
 560      00000000 
 560      00000000 
 563              	rand_state:
 564 2000 00000000 		.space	4
 565              		.text
 566              	.Letext0:
 567              		.file 2 "c:\\gcc\\arm-none-eabi\\include\\machine\\_default_types.h"
 568              		.file 3 "c:\\gcc\\arm-none-eabi\\include\\sys\\_stdint.h"
