   1              		.syntax unified
   2              		.cpu cortex-m4
   3              		.fpu softvfp
   4              		.eabi_attribute 20, 1
   5              		.eabi_attribute 21, 1
   6              		.eabi_attribute 23, 3
   7              		.eabi_attribute 24, 1
   8              		.eabi_attribute 25, 1
   9              		.eabi_attribute 26, 1
  10              		.eabi_attribute 30, 2
  11              		.eabi_attribute 34, 1
  12              		.eabi_attribute 18, 4
  13              		.thumb
  14              		.syntax unified
  15              		.file	"gol_benchmark.c"
  16              		.text
  17              	.Ltext0:
  18              		.cfi_sections	.debug_frame
  19              		.align	2
  20              		.global	Gol_Benchmark_8
  21              		.thumb
  22              		.thumb_func
  24              	Gol_Benchmark_8:
  25              	.LFB5:
  26              		.file 1 "gol_benchmark.c"
   1:gol_benchmark.c **** /*************************************************************************
   2:gol_benchmark.c **** "Conway's Game of Life" benchmark for 8 bit and 32 bit data types.
   3:gol_benchmark.c **** The calculations start with a pseudo-random, but reproducible world. The
   4:gol_benchmark.c **** calculations are identical in every benchmark call with the same number
   5:gol_benchmark.c **** of generations.
   6:gol_benchmark.c **** 
   7:gol_benchmark.c **** resource requirements:
   8:gol_benchmark.c **** needs about 8 kB RAM for the "game of life" worlds at 32x32 cells.
   9:gol_benchmark.c **** 
  10:gol_benchmark.c **** external requirements:
  11:gol_benchmark.c **** needs the following get-time function:
  12:gol_benchmark.c **** int32_t Get_Time(void);
  13:gol_benchmark.c **** 
  14:gol_benchmark.c **** benchmark functions:
  15:gol_benchmark.c **** int32_t Gol_Benchmark_8(uint32_t num_generations);
  16:gol_benchmark.c **** int32_t Gol_Benchmark_32(uint32_t num_generations);
  17:gol_benchmark.c **** 
  18:gol_benchmark.c **** input:        desired number of generations.
  19:gol_benchmark.c **** 
  20:gol_benchmark.c **** output:       difference between Get_Time() at start and end, in whatever
  21:gol_benchmark.c ****               unit the Get_Time() function is using. The initialization
  22:gol_benchmark.c ****               is not part of the benchmark.
  23:gol_benchmark.c **** 
  24:gol_benchmark.c **** side effects: the volatile global variable "prevent_compiler_opt" is set
  25:gol_benchmark.c ****               to the final state of the middle "game of life" cell. This
  26:gol_benchmark.c ****               keeps the compiler from optimizing the benchmark away.
  27:gol_benchmark.c **** 
  28:gol_benchmark.c **** limitations:  cell 0 is not updated, and the border wrapping is strange,
  29:gol_benchmark.c ****               but it doesn't matter for benchmarking.
  30:gol_benchmark.c **** *************************************************************************/
  31:gol_benchmark.c **** 
  32:gol_benchmark.c **** #include <stdint.h>
  33:gol_benchmark.c **** 
  34:gol_benchmark.c **** //#define SIGNED_TEST
  35:gol_benchmark.c **** 
  36:gol_benchmark.c **** #ifdef SIGNED_TEST
  37:gol_benchmark.c ****     #define INT8 int8_t
  38:gol_benchmark.c ****     #define INT32 int32_t
  39:gol_benchmark.c **** #else
  40:gol_benchmark.c ****     #define INT8 uint8_t
  41:gol_benchmark.c ****     #define INT32 uint32_t
  42:gol_benchmark.c **** #endif
  43:gol_benchmark.c **** 
  44:gol_benchmark.c **** #define DEAD      0
  45:gol_benchmark.c **** #define ALIVE     1U
  46:gol_benchmark.c **** 
  47:gol_benchmark.c **** /*must be powers of 2*/
  48:gol_benchmark.c **** #define ROWS      32UL
  49:gol_benchmark.c **** #define COLS      32UL
  50:gol_benchmark.c **** 
  51:gol_benchmark.c **** #define WRAP_MASK (ROWS * COLS - 1UL)
  52:gol_benchmark.c **** 
  53:gol_benchmark.c **** extern int32_t Get_Time(void);
  54:gol_benchmark.c **** 
  55:gol_benchmark.c **** volatile INT32 prevent_compiler_opt;
  56:gol_benchmark.c **** 
  57:gol_benchmark.c **** /*reuse the worlds for the 8 bit test via pointer casting*/
  58:gol_benchmark.c **** static INT32 world_0[ROWS * COLS];
  59:gol_benchmark.c **** static INT32 world_1[ROWS * COLS];
  60:gol_benchmark.c **** 
  61:gol_benchmark.c **** static uint32_t rand_state;
  62:gol_benchmark.c **** 
  63:gol_benchmark.c **** static uint32_t Random(uint32_t max_val) {
  64:gol_benchmark.c ****     rand_state *= 1103515245UL;
  65:gol_benchmark.c ****     rand_state += 12345UL;
  66:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
  67:gol_benchmark.c **** }
  68:gol_benchmark.c **** 
  69:gol_benchmark.c **** static void Gol_Init_8(INT8 *world_8) {
  70:gol_benchmark.c ****     uint32_t cnt;
  71:gol_benchmark.c ****     rand_state = 42UL; /*pseudo-random, reproducible init*/
  72:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
  73:gol_benchmark.c ****         world_8[cnt] = (INT8) Random(ALIVE+1UL);
  74:gol_benchmark.c **** }
  75:gol_benchmark.c **** 
  76:gol_benchmark.c **** static void Gol_Init_32(INT32 *world_32) {
  77:gol_benchmark.c ****     uint32_t cnt;
  78:gol_benchmark.c ****     rand_state = 42UL; /*pseudo-random, reproducible init*/
  79:gol_benchmark.c ****     for (cnt = 0; cnt < ROWS * COLS; cnt++)
  80:gol_benchmark.c ****         world_32[cnt] = (INT32) Random(ALIVE+1UL);
  81:gol_benchmark.c **** }
  82:gol_benchmark.c **** 
  83:gol_benchmark.c **** static void Gol_Iteration_8(const INT8 *old_world, INT8 *new_world) {
  84:gol_benchmark.c ****     uint32_t base_cell;
  85:gol_benchmark.c ****     /*some simplifications here to avoid benchmarking the loop overhead
  86:gol_benchmark.c ****       or the wrapping.
  87:gol_benchmark.c ****       cell 0 is not updated, and the wrapping is strange, but it doesn't
  88:gol_benchmark.c ****       matter for benchmarking.*/
  89:gol_benchmark.c ****     for (base_cell = ROWS * COLS - 1UL; base_cell != 0; base_cell--) {
  90:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
  91:gol_benchmark.c **** 
  92:gol_benchmark.c ****         /*counting from upper left adjacent, clockwise*/
  93:gol_benchmark.c ****         living_adjacents  = old_world[(base_cell - COLS - 1UL) & WRAP_MASK];
  94:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
  95:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
  96:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
  97:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
  98:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
  99:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 100:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 101:gol_benchmark.c **** 
 102:gol_benchmark.c ****         cell_state = old_world[base_cell];
 103:gol_benchmark.c ****         if (cell_state == DEAD) {
 104:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 105:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 106:gol_benchmark.c ****             else
 107:gol_benchmark.c ****                 new_world[base_cell] = DEAD;
 108:gol_benchmark.c ****         } else { /*cell has been alive*/
 109:gol_benchmark.c ****             if ((living_adjacents == 2) || (living_adjacents == 3))
 110:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 111:gol_benchmark.c ****             else
 112:gol_benchmark.c ****                 new_world[base_cell] = DEAD; /*cell dies*/
 113:gol_benchmark.c ****         }
 114:gol_benchmark.c ****     }
 115:gol_benchmark.c **** }
 116:gol_benchmark.c **** 
 117:gol_benchmark.c **** static void Gol_Iteration_32(const INT32 *old_world, INT32 *new_world) {
 118:gol_benchmark.c ****     uint32_t base_cell;
 119:gol_benchmark.c ****     /*some simplifications here to avoid benchmarking the loop overhead
 120:gol_benchmark.c ****       or the wrapping.
 121:gol_benchmark.c ****       cell 0 is not updated, and the wrapping is strange, but it doesn't
 122:gol_benchmark.c ****       matter for benchmarking.*/
 123:gol_benchmark.c ****     for (base_cell = ROWS * COLS - 1UL; base_cell != 0; base_cell--) {
 124:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 125:gol_benchmark.c **** 
 126:gol_benchmark.c ****         /*counting from upper left adjacent, clockwise*/
 127:gol_benchmark.c ****         living_adjacents  = old_world[(base_cell - COLS - 1UL) & WRAP_MASK];
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 129:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 130:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 131:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 132:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 133:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 134:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 135:gol_benchmark.c **** 
 136:gol_benchmark.c ****         cell_state = old_world[base_cell];
 137:gol_benchmark.c ****         if (cell_state == DEAD) {
 138:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 139:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 140:gol_benchmark.c ****             else
 141:gol_benchmark.c ****                 new_world[base_cell] = DEAD;
 142:gol_benchmark.c ****         } else { /*cell has been alive*/
 143:gol_benchmark.c ****             if ((living_adjacents == 2) || (living_adjacents == 3))
 144:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 145:gol_benchmark.c ****             else
 146:gol_benchmark.c ****                 new_world[base_cell] = DEAD; /*cell dies*/
 147:gol_benchmark.c ****         }
 148:gol_benchmark.c ****     }
 149:gol_benchmark.c **** }
 150:gol_benchmark.c **** 
 151:gol_benchmark.c **** /*the 8 bit benchmark API function*/
 152:gol_benchmark.c **** int32_t Gol_Benchmark_8(uint32_t num_generations) {
  27              		.loc 1 152 0
  28              		.cfi_startproc
  29              		@ args = 0, pretend = 0, frame = 0
  30              		@ frame_needed = 0, uses_anonymous_args = 0
  31              	.LVL0:
  32 0000 3F4A     		ldr	r2, .L19
  33 0002 2DE9F84F 		push	{r3, r4, r5, r6, r7, r8, r9, r10, fp, lr}
  34              		.cfi_def_cfa_offset 40
  35              		.cfi_offset 3, -40
  36              		.cfi_offset 4, -36
  37              		.cfi_offset 5, -32
  38              		.cfi_offset 6, -28
  39              		.cfi_offset 7, -24
  40              		.cfi_offset 8, -20
  41              		.cfi_offset 9, -16
  42              		.cfi_offset 10, -12
  43              		.cfi_offset 11, -8
  44              		.cfi_offset 14, -4
  45              	.LBB24:
  46              	.LBB25:
  47              	.LBB26:
  48              	.LBB27:
  65:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
  49              		.loc 1 65 0
  50 0006 3F4C     		ldr	r4, .L19+4
  51              	.LBE27:
  52              	.LBE26:
  53              	.LBE25:
  54              	.LBE24:
  55              		.loc 1 152 0
  56 0008 8046     		mov	r8, r0
  57 000a 2A23     		movs	r3, #42
  58 000c 02F58060 		add	r0, r2, #1024
  59              	.LVL1:
  60              	.L2:
  61              	.LBB31:
  62              	.LBB30:
  63              	.LBB29:
  64              	.LBB28:
  65:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
  65              		.loc 1 65 0
  66 0010 04FB03F3 		mul	r3, r4, r3
  67 0014 03F54053 		add	r3, r3, #12288
  68 0018 3933     		adds	r3, r3, #57
  69              	.LVL2:
  70              	.LBE28:
  71              	.LBE29:
  73:gol_benchmark.c **** }
  72              		.loc 1 73 0
  73 001a C3F30041 		ubfx	r1, r3, #16, #1
  74 001e 02F8011F 		strb	r1, [r2, #1]!
  75              	.LVL3:
  72:gol_benchmark.c ****         world_8[cnt] = (INT8) Random(ALIVE+1UL);
  76              		.loc 1 72 0
  77 0022 8242     		cmp	r2, r0
  78 0024 F4D1     		bne	.L2
  79 0026 384C     		ldr	r4, .L19+8
  80 0028 C4F8083F 		str	r3, [r4, #3848]
  81              	.LVL4:
  82              	.LBE30:
  83              	.LBE31:
 153:gol_benchmark.c ****     INT8 *old_world, *new_world;
 154:gol_benchmark.c ****     int32_t start_time, end_time;
 155:gol_benchmark.c ****     uint32_t cnt;
 156:gol_benchmark.c ****     /*set up buffers*/
 157:gol_benchmark.c ****     old_world = (INT8 *) world_0;
 158:gol_benchmark.c ****     new_world = (INT8 *) world_1;
 159:gol_benchmark.c ****     /*init time does not count*/
 160:gol_benchmark.c ****     Gol_Init_8(old_world);
 161:gol_benchmark.c ****     start_time = Get_Time();
  84              		.loc 1 161 0
  85 002c FFF7FEFF 		bl	Get_Time
  86              	.LVL5:
  87 0030 8146     		mov	r9, r0
  88              	.LVL6:
 162:gol_benchmark.c **** 
 163:gol_benchmark.c ****     for (cnt = num_generations; cnt != 0; cnt--) {
  89              		.loc 1 163 0
  90 0032 B8F1000F 		cmp	r8, #0
  91 0036 58D0     		beq	.L10
  92 0038 A4F1F802 		sub	r2, r4, #248
  93 003c 334C     		ldr	r4, .L19+12
  94              	.LBB32:
  95              	.LBB33:
  96              	.LBB34:
  97              	.LBB35:
 112:gol_benchmark.c ****         }
  98              		.loc 1 112 0
  99 003e 4FF0000C 		mov	ip, #0
 110:gol_benchmark.c ****             else
 100              		.loc 1 110 0
 101 0042 4FF0010A 		mov	r10, #1
 102              	.LVL7:
 103              	.L9:
 104 0046 02F2FF37 		addw	r7, r2, #1023
 105 004a 04F2FF3E 		addw	lr, r4, #1023
 106              	.LBE35:
 107              	.LBE34:
 108              	.LBE33:
 109              	.LBE32:
 110 004e 40F2DE33 		movw	r3, #990
 111 0052 09E0     		b	.L8
 112              	.LVL8:
 113              	.L18:
 114              	.LBB44:
 115              	.LBB42:
 116              	.LBB40:
 117              	.LBB36:
 104:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 118              		.loc 1 104 0
 119 0054 0329     		cmp	r1, #3
 120 0056 45D0     		beq	.L15
 107:gol_benchmark.c ****         } else { /*cell has been alive*/
 121              		.loc 1 107 0
 122 0058 8EF80050 		strb	r5, [lr]
 123              	.L6:
 124              	.LVL9:
 125 005c 013B     		subs	r3, r3, #1
 126              	.LVL10:
 127              	.LBE36:
  89:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
 128              		.loc 1 89 0
 129 005e 13F1210F 		cmn	r3, #33
 130 0062 0EF1FF3E 		add	lr, lr, #-1
 131 0066 36D0     		beq	.L17
 132              	.LVL11:
 133              	.L8:
 134              	.LBB37:
  94:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 135              		.loc 1 94 0
 136 0068 581C     		adds	r0, r3, #1
 137 006a C0F30900 		ubfx	r0, r0, #0, #10
  93:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 138              		.loc 1 93 0
 139 006e C3F30901 		ubfx	r1, r3, #0, #10
  95:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 140              		.loc 1 95 0
 141 0072 9D1C     		adds	r5, r3, #2
 142 0074 165C     		ldrb	r6, [r2, r0]	@ zero_extendqisi2
  93:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 143              		.loc 1 93 0
 144 0076 505C     		ldrb	r0, [r2, r1]	@ zero_extendqisi2
 145              	.LVL12:
 146 0078 17F8011D 		ldrb	r1, [r7, #-1]!	@ zero_extendqisi2
  95:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 147              		.loc 1 95 0
 148 007c C5F30905 		ubfx	r5, r5, #0, #10
  96:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 149              		.loc 1 96 0
 150 0080 03F1220B 		add	fp, r3, #34
 151 0084 3044     		add	r0, r0, r6
 152              	.LVL13:
 153 0086 555D     		ldrb	r5, [r2, r5]	@ zero_extendqisi2
 154 0088 CBF3090B 		ubfx	fp, fp, #0, #10
  97:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 155              		.loc 1 97 0
 156 008c 03F14206 		add	r6, r3, #66
 157 0090 0144     		add	r1, r1, r0
 158 0092 C6F30906 		ubfx	r6, r6, #0, #10
  98:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 159              		.loc 1 98 0
 160 0096 03F14100 		add	r0, r3, #65
 161 009a 2944     		add	r1, r1, r5
 162 009c 12F80BB0 		ldrb	fp, [r2, fp]	@ zero_extendqisi2
 163 00a0 965D     		ldrb	r6, [r2, r6]	@ zero_extendqisi2
 164 00a2 C0F30900 		ubfx	r0, r0, #0, #10
  99:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 165              		.loc 1 99 0
 166 00a6 03F14005 		add	r5, r3, #64
 167 00aa C5F30905 		ubfx	r5, r5, #0, #10
 168 00ae 105C     		ldrb	r0, [r2, r0]	@ zero_extendqisi2
 169 00b0 5944     		add	r1, r1, fp
 170 00b2 3144     		add	r1, r1, r6
 100:gol_benchmark.c **** 
 171              		.loc 1 100 0
 172 00b4 565D     		ldrb	r6, [r2, r5]	@ zero_extendqisi2
 103:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 173              		.loc 1 103 0
 174 00b6 7D78     		ldrb	r5, [r7, #1]	@ zero_extendqisi2
 175 00b8 0144     		add	r1, r1, r0
 100:gol_benchmark.c **** 
 176              		.loc 1 100 0
 177 00ba 3144     		add	r1, r1, r6
 178              	.LVL14:
 109:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 179              		.loc 1 109 0
 180 00bc 881E     		subs	r0, r1, #2
 103:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 181              		.loc 1 103 0
 182 00be 002D     		cmp	r5, #0
 183 00c0 C8D0     		beq	.L18
 109:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 184              		.loc 1 109 0
 185 00c2 0128     		cmp	r0, #1
 186 00c4 0ED9     		bls	.L15
 187 00c6 013B     		subs	r3, r3, #1
 188              	.LVL15:
 189              	.LBE37:
  89:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
 190              		.loc 1 89 0
 191 00c8 13F1210F 		cmn	r3, #33
 192              	.LBB38:
 112:gol_benchmark.c ****         }
 193              		.loc 1 112 0
 194 00cc 8EF800C0 		strb	ip, [lr]
 195              	.LVL16:
 196 00d0 0EF1FF3E 		add	lr, lr, #-1
 197              	.LBE38:
  89:gol_benchmark.c ****         INT32 cell_state, living_adjacents;
 198              		.loc 1 89 0
 199 00d4 C8D1     		bne	.L8
 200              	.L17:
 201              	.LVL17:
 202              	.LBE40:
 203              	.LBE42:
 204              	.LBE44:
 205              		.loc 1 163 0 discriminator 3
 206 00d6 B8F10108 		subs	r8, r8, #1
 207              	.LVL18:
 208 00da 07D0     		beq	.L3
 209 00dc 1346     		mov	r3, r2
 210 00de 2246     		mov	r2, r4
 211              	.LVL19:
 212 00e0 1C46     		mov	r4, r3
 213              	.LVL20:
 214 00e2 B0E7     		b	.L9
 215              	.LVL21:
 216              	.L15:
 217              	.LBB45:
 218              	.LBB43:
 219              	.LBB41:
 220              	.LBB39:
 110:gol_benchmark.c ****             else
 221              		.loc 1 110 0
 222 00e4 8EF800A0 		strb	r10, [lr]
 223 00e8 B8E7     		b	.L6
 224              	.LVL22:
 225              	.L10:
 226              	.LBE39:
 227              	.LBE41:
 228              	.LBE43:
 229              	.LBE45:
 157:gol_benchmark.c ****     new_world = (INT8 *) world_1;
 230              		.loc 1 157 0
 231 00ea F83C     		subs	r4, r4, #248
 232              	.LVL23:
 233              	.L3:
 164:gol_benchmark.c ****         INT8 *tmp_ptr;
 165:gol_benchmark.c ****         Gol_Iteration_8(old_world, new_world);
 166:gol_benchmark.c ****         /*switch buffers*/
 167:gol_benchmark.c ****         tmp_ptr = old_world;
 168:gol_benchmark.c ****         old_world = new_world;
 169:gol_benchmark.c ****         new_world = tmp_ptr;
 170:gol_benchmark.c ****     }
 171:gol_benchmark.c **** 
 172:gol_benchmark.c ****     end_time = Get_Time();
 234              		.loc 1 172 0
 235 00ec FFF7FEFF 		bl	Get_Time
 236              	.LVL24:
 173:gol_benchmark.c ****     prevent_compiler_opt = old_world[ROWS * COLS / 2UL];
 237              		.loc 1 173 0
 238 00f0 074B     		ldr	r3, .L19+16
 239 00f2 94F80022 		ldrb	r2, [r4, #512]	@ zero_extendqisi2
 240 00f6 1A60     		str	r2, [r3]
 174:gol_benchmark.c ****     return(end_time - start_time);
 175:gol_benchmark.c **** }
 241              		.loc 1 175 0
 242 00f8 C9EB0000 		rsb	r0, r9, r0
 243              	.LVL25:
 244 00fc BDE8F88F 		pop	{r3, r4, r5, r6, r7, r8, r9, r10, fp, pc}
 245              	.LVL26:
 246              	.L20:
 247              		.align	2
 248              	.L19:
 249 0100 FF0F0000 		.word	.LANCHOR1-249
 250 0104 6D4EC641 		.word	1103515245
 251 0108 F8100000 		.word	.LANCHOR1
 252 010c 00000000 		.word	.LANCHOR0
 253 0110 00000000 		.word	prevent_compiler_opt
 254              		.cfi_endproc
 255              	.LFE5:
 257              		.align	2
 258              		.global	Gol_Benchmark_32
 259              		.thumb
 260              		.thumb_func
 262              	Gol_Benchmark_32:
 263              	.LFB6:
 176:gol_benchmark.c **** 
 177:gol_benchmark.c **** /*the 32 bit benchmark API function*/
 178:gol_benchmark.c **** int32_t Gol_Benchmark_32(uint32_t num_generations) {
 264              		.loc 1 178 0
 265              		.cfi_startproc
 266              		@ args = 0, pretend = 0, frame = 0
 267              		@ frame_needed = 0, uses_anonymous_args = 0
 268              	.LVL27:
 269 0114 454A     		ldr	r2, .L38
 270 0116 2DE9F84F 		push	{r3, r4, r5, r6, r7, r8, r9, r10, fp, lr}
 271              		.cfi_def_cfa_offset 40
 272              		.cfi_offset 3, -40
 273              		.cfi_offset 4, -36
 274              		.cfi_offset 5, -32
 275              		.cfi_offset 6, -28
 276              		.cfi_offset 7, -24
 277              		.cfi_offset 8, -20
 278              		.cfi_offset 9, -16
 279              		.cfi_offset 10, -12
 280              		.cfi_offset 11, -8
 281              		.cfi_offset 14, -4
 282              	.LBB54:
 283              	.LBB55:
 284              	.LBB56:
 285              	.LBB57:
  65:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
 286              		.loc 1 65 0
 287 011a 454C     		ldr	r4, .L38+4
 288              	.LBE57:
 289              	.LBE56:
 290              	.LBE55:
 291              	.LBE54:
 292              		.loc 1 178 0
 293 011c 8046     		mov	r8, r0
 294 011e 2A23     		movs	r3, #42
 295 0120 02F58050 		add	r0, r2, #4096
 296              	.LVL28:
 297              	.L22:
 298              	.LBB61:
 299              	.LBB60:
 300              	.LBB59:
 301              	.LBB58:
  65:gol_benchmark.c ****     return((rand_state >> 16U) % max_val);
 302              		.loc 1 65 0
 303 0124 04FB03F3 		mul	r3, r4, r3
 304 0128 03F54053 		add	r3, r3, #12288
 305 012c 3933     		adds	r3, r3, #57
 306              	.LVL29:
 307              	.LBE58:
 308              	.LBE59:
  80:gol_benchmark.c **** }
 309              		.loc 1 80 0
 310 012e C3F30041 		ubfx	r1, r3, #16, #1
 311 0132 42F8041F 		str	r1, [r2, #4]!
  79:gol_benchmark.c ****         world_32[cnt] = (INT32) Random(ALIVE+1UL);
 312              		.loc 1 79 0
 313 0136 8242     		cmp	r2, r0
 314 0138 F4D1     		bne	.L22
 315 013a 3E4C     		ldr	r4, .L38+8
 316 013c C4F8083F 		str	r3, [r4, #3848]
 317              	.LVL30:
 318              	.LBE60:
 319              	.LBE61:
 179:gol_benchmark.c ****     INT32 *old_world, *new_world;
 180:gol_benchmark.c ****     int32_t start_time, end_time;
 181:gol_benchmark.c ****     uint32_t cnt;
 182:gol_benchmark.c ****     /*set up buffers*/
 183:gol_benchmark.c ****     old_world = world_0;
 184:gol_benchmark.c ****     new_world = world_1;
 185:gol_benchmark.c ****     /*init time does not count*/
 186:gol_benchmark.c ****     Gol_Init_32(old_world);
 187:gol_benchmark.c ****     start_time = Get_Time();
 320              		.loc 1 187 0
 321 0140 FFF7FEFF 		bl	Get_Time
 322              	.LVL31:
 323 0144 8146     		mov	r9, r0
 324              	.LVL32:
 188:gol_benchmark.c **** 
 189:gol_benchmark.c ****     for (cnt = num_generations; cnt != 0; cnt--) {
 325              		.loc 1 189 0
 326 0146 B8F1000F 		cmp	r8, #0
 327 014a 62D0     		beq	.L30
 328 014c DFF8ECA0 		ldr	r10, .L38+16
 329 0150 A4F1F800 		sub	r0, r4, #248
 330              	.LVL33:
 331              	.LBB62:
 332              	.LBB63:
 333              	.LBB64:
 334              	.LBB65:
 146:gol_benchmark.c ****         }
 335              		.loc 1 146 0
 336 0154 4FF0000E 		mov	lr, #0
 144:gol_benchmark.c ****             else
 337              		.loc 1 144 0
 338 0158 4FF0010C 		mov	ip, #1
 339              	.LVL34:
 340              	.L29:
 341 015c 00F6FC77 		addw	r7, r0, #4092
 342 0160 00F58056 		add	r6, r0, #4096
 343 0164 0AF6FC75 		addw	r5, r10, #4092
 344              	.LBE65:
 345              	.LBE64:
 346              	.LBE63:
 347              	.LBE62:
 348 0168 40F2FF31 		movw	r1, #1023
 349 016c 07E0     		b	.L28
 350              	.LVL35:
 351              	.L37:
 352              	.LBB74:
 353              	.LBB72:
 354              	.LBB70:
 355              	.LBB66:
 138:gol_benchmark.c ****                 new_world[base_cell] = ALIVE;
 356              		.loc 1 138 0
 357 016e 032B     		cmp	r3, #3
 358 0170 4CD0     		beq	.L35
 141:gol_benchmark.c ****         } else { /*cell has been alive*/
 359              		.loc 1 141 0
 360 0172 C5F800B0 		str	fp, [r5]
 361              	.L26:
 362              	.LVL36:
 363              	.LBE66:
 123:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 364              		.loc 1 123 0
 365 0176 0139     		subs	r1, r1, #1
 366              	.LVL37:
 367 0178 A5F10405 		sub	r5, r5, #4
 368 017c 3FD0     		beq	.L36
 369              	.LVL38:
 370              	.L28:
 371              	.LBB67:
 127:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 372              		.loc 1 127 0
 373 017e A1F12104 		sub	r4, r1, #33
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 374              		.loc 1 128 0
 375 0182 A1F12002 		sub	r2, r1, #32
 127:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 376              		.loc 1 127 0
 377 0186 C4F30904 		ubfx	r4, r4, #0, #10
 128:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS + 1UL) & WRAP_MASK];
 378              		.loc 1 128 0
 379 018a C2F30902 		ubfx	r2, r2, #0, #10
 127:gol_benchmark.c ****         living_adjacents += old_world[(base_cell - COLS      ) & WRAP_MASK];
 380              		.loc 1 127 0
 381 018e 50F82440 		ldr	r4, [r0, r4, lsl #2]
 382              	.LVL39:
 383 0192 50F82220 		ldr	r2, [r0, r2, lsl #2]
 384 0196 57F804BD 		ldr	fp, [r7, #-4]!
 129:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        + 1UL) & WRAP_MASK];
 385              		.loc 1 129 0
 386 019a A1F11F03 		sub	r3, r1, #31
 387 019e 2244     		add	r2, r2, r4
 388 01a0 C3F30903 		ubfx	r3, r3, #0, #10
 130:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS + 1UL) & WRAP_MASK];
 389              		.loc 1 130 0
 390 01a4 4C1C     		adds	r4, r1, #1
 391              	.LVL40:
 392 01a6 C4F30904 		ubfx	r4, r4, #0, #10
 393 01aa 50F82330 		ldr	r3, [r0, r3, lsl #2]
 394 01ae 50F82440 		ldr	r4, [r0, r4, lsl #2]
 395 01b2 5A44     		add	r2, r2, fp
 131:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS      ) & WRAP_MASK];
 396              		.loc 1 131 0
 397 01b4 01F1210B 		add	fp, r1, #33
 398 01b8 1344     		add	r3, r3, r2
 399 01ba CBF3090B 		ubfx	fp, fp, #0, #10
 132:gol_benchmark.c ****         living_adjacents += old_world[(base_cell + COLS - 1UL) & WRAP_MASK];
 400              		.loc 1 132 0
 401 01be 01F12002 		add	r2, r1, #32
 402 01c2 2344     		add	r3, r3, r4
 403 01c4 C2F30902 		ubfx	r2, r2, #0, #10
 133:gol_benchmark.c ****         living_adjacents += old_world[(base_cell        - 1UL) & WRAP_MASK];
 404              		.loc 1 133 0
 405 01c8 01F11F04 		add	r4, r1, #31
 406 01cc 50F82BB0 		ldr	fp, [r0, fp, lsl #2]
 407 01d0 50F82220 		ldr	r2, [r0, r2, lsl #2]
 408 01d4 C4F30904 		ubfx	r4, r4, #0, #10
 409 01d8 5B44     		add	r3, r3, fp
 134:gol_benchmark.c **** 
 410              		.loc 1 134 0
 411 01da 50F82440 		ldr	r4, [r0, r4, lsl #2]
 137:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 412              		.loc 1 137 0
 413 01de 56F804BD 		ldr	fp, [r6, #-4]!
 414 01e2 1344     		add	r3, r3, r2
 134:gol_benchmark.c **** 
 415              		.loc 1 134 0
 416 01e4 2344     		add	r3, r3, r4
 417              	.LVL41:
 143:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 418              		.loc 1 143 0
 419 01e6 9A1E     		subs	r2, r3, #2
 137:gol_benchmark.c ****             if (living_adjacents == 3) /*cell born*/
 420              		.loc 1 137 0
 421 01e8 BBF1000F 		cmp	fp, #0
 422 01ec BFD0     		beq	.L37
 143:gol_benchmark.c ****                 new_world[base_cell] = ALIVE; /*cell survives*/
 423              		.loc 1 143 0
 424 01ee 012A     		cmp	r2, #1
 425 01f0 0CD9     		bls	.L35
 426              	.LBE67:
 123:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 427              		.loc 1 123 0
 428 01f2 0139     		subs	r1, r1, #1
 429              	.LVL42:
 430              	.LBB68:
 146:gol_benchmark.c ****         }
 431              		.loc 1 146 0
 432 01f4 C5F800E0 		str	lr, [r5]
 433              	.LVL43:
 434 01f8 A5F10405 		sub	r5, r5, #4
 435              	.LBE68:
 123:gol_benchmark.c ****         INT32 living_adjacents, cell_state;
 436              		.loc 1 123 0
 437 01fc BFD1     		bne	.L28
 438              	.L36:
 439              	.LVL44:
 440              	.LBE70:
 441              	.LBE72:
 442              	.LBE74:
 443              		.loc 1 189 0 discriminator 3
 444 01fe B8F10108 		subs	r8, r8, #1
 445              	.LVL45:
 446 0202 08D0     		beq	.L23
 447 0204 0346     		mov	r3, r0
 448 0206 5046     		mov	r0, r10
 449              	.LVL46:
 450 0208 9A46     		mov	r10, r3
 451              	.LVL47:
 452 020a A7E7     		b	.L29
 453              	.LVL48:
 454              	.L35:
 455              	.LBB75:
 456              	.LBB73:
 457              	.LBB71:
 458              	.LBB69:
 144:gol_benchmark.c ****             else
 459              		.loc 1 144 0
 460 020c C5F800C0 		str	ip, [r5]
 461 0210 B1E7     		b	.L26
 462              	.LVL49:
 463              	.L30:
 464              	.LBE69:
 465              	.LBE71:
 466              	.LBE73:
 467              	.LBE75:
 183:gol_benchmark.c ****     new_world = world_1;
 468              		.loc 1 183 0
 469 0212 A4F1F80A 		sub	r10, r4, #248
 470              	.LVL50:
 471              	.L23:
 190:gol_benchmark.c ****         INT32 *tmp_ptr;
 191:gol_benchmark.c ****         Gol_Iteration_32(old_world, new_world);
 192:gol_benchmark.c ****         /*switch buffers*/
 193:gol_benchmark.c ****         tmp_ptr = old_world;
 194:gol_benchmark.c ****         old_world = new_world;
 195:gol_benchmark.c ****         new_world = tmp_ptr;
 196:gol_benchmark.c ****     }
 197:gol_benchmark.c **** 
 198:gol_benchmark.c ****     end_time = Get_Time();
 472              		.loc 1 198 0
 473 0216 FFF7FEFF 		bl	Get_Time
 474              	.LVL51:
 199:gol_benchmark.c ****     prevent_compiler_opt = old_world[ROWS * COLS / 2UL];
 475              		.loc 1 199 0
 476 021a 074B     		ldr	r3, .L38+12
 477 021c DAF80028 		ldr	r2, [r10, #2048]
 478 0220 1A60     		str	r2, [r3]
 200:gol_benchmark.c ****     return(end_time - start_time);
 201:gol_benchmark.c **** }
 479              		.loc 1 201 0
 480 0222 C9EB0000 		rsb	r0, r9, r0
 481              	.LVL52:
 482 0226 BDE8F88F 		pop	{r3, r4, r5, r6, r7, r8, r9, r10, fp, pc}
 483              	.LVL53:
 484              	.L39:
 485 022a 00BF     		.align	2
 486              	.L38:
 487 022c FC0F0000 		.word	.LANCHOR1-252
 488 0230 6D4EC641 		.word	1103515245
 489 0234 F8100000 		.word	.LANCHOR1
 490 0238 00000000 		.word	prevent_compiler_opt
 491 023c 00000000 		.word	.LANCHOR0
 492              		.cfi_endproc
 493              	.LFE6:
 495              		.comm	prevent_compiler_opt,4,4
 496              		.bss
 497              		.align	2
 498              		.set	.LANCHOR0,. + 0
 499              		.set	.LANCHOR1,. + 4344
 502              	world_1:
 503 0000 00000000 		.space	4096
 503      00000000 
 503      00000000 
 503      00000000 
 503      00000000 
 506              	world_0:
 507 1000 00000000 		.space	4096
 507      00000000 
 507      00000000 
 507      00000000 
 507      00000000 
 510              	rand_state:
 511 2000 00000000 		.space	4
 512              		.text
 513              	.Letext0:
 514              		.file 2 "c:\\gcc\\arm-none-eabi\\include\\machine\\_default_types.h"
 515              		.file 3 "c:\\gcc\\arm-none-eabi\\include\\sys\\_stdint.h"
